
Function KnotOnPos%(x,y)
	For k.TPathKnots = Each TPathKnots
		If( k\x =x) And (k\y = y) Then Return Handle(k)
	Next
	Return 0
End Function

Function GetParentP.TPathKnots(parent.TPathKnots)
	For k.TPathKnots = Each TPathKnots
		If( k\parent=parent) Then Return k
	Next
	Return Null
End Function


Function KnotOnPosUpdate%(x,y)
	For k.TPathKnotsUpdate = Each TPathKnotsUpdate
		If( k\x =x) And (k\y = y) Then Return Handle(k)
	Next
	Return 0
End Function

Function DeletePath()
	Local k.TPathKnots
	For k = Each TPathKnots
		FreeEntity k\piv 
		Delete k
	Next
End Function

Function PathCheck(StartX,StartY, DestinationX%,DestinationY%)
	
	Local Knot.TPathKnots = New TPathKnots
	Knot\X =	StartX
	Knot\Y = 	StartY
	Knot\Attr = 2^30
	Knot\piv = CreatePivot()
	
	Repeat
		Local x,y
		Local Error%=0
		
		Local k.TPathKnots
		Knot = First TPathKnots
		
		For k = Each TPathKnots
			If k\Attr <= Knot\Attr And  k\done = 0 Then Knot = k
		Next
		
		Knot\done = 1
		
		If Knot\X = DestinationX And Knot\Y = DestinationY
			k.TPathKnots = Last TPathKnots
			
			Repeat
				If DEBUG_PATHFINDING Then
					k\piv = CreateCone()
				Else
					k\piv = CreatePivot()
				EndIf
				
				PositionEntity k\piv,k\X,0,k\Y
				
				k\done = 2
				k=k\parent
				
			Until k\X = StartX And k\Y = StartY
			
			For Knot.TPathKnots = Each TPathKnots
				If Knot\done <> 2 Then Delete Knot
			Next
			Return 1
		EndIf
		
		
		Local jump
		For x = -1 To 1
			For y = -1 To 1
				If (Not(x=0 And y=0)) And (MMap(70+Knot\X + x,70+Knot\Y + y) =0) Then
					If x = 1 And y = 1 Then
						If (MMap(70+Knot\X + 1,70+Knot\Y + 0) = 1) Or (MMap(70+Knot\X + 0,70+Knot\Y - 1) =1) 
							jump = 1
						EndIf
					ElseIf x = -1 And y = -1 Then
						If (MMap(70+Knot\X - 1,70+Knot\Y + 0) =1) Or (MMap(70+Knot\X + 0,70+Knot\Y - 1) =1) 
							jump = 1
						EndIf
					ElseIf x = 1 And y = -1 Then
						If (MMap(70+Knot\X ,70+Knot\Y - 1) =1) Or (MMap(70+Knot\X + 1,70+Knot\Y ) =1) 
							jump = 1
						EndIf
					ElseIf x = -1 And y = 1 Then
						If (MMap(70+Knot\X-1 ,70+Knot\Y ) =1) Or (MMap(70+Knot\X,70+Knot\Y+1 ) =1) 
							jump = 1
						EndIf
					EndIf
					If jump=0 Then
						If KnotOnPos(Knot\X + x,Knot\Y + y) = 0 Then
							
							Local P.TPathKnots = New TPathKnots
							
							If (x= -1 Or x=1) And y=0 Then
								P\F = 10
							ElseIf (y= -1 Or y=1) And x=0 Then
								P\F = 10
							Else
								P\F = 14
							EndIf
							P\X = Knot\X + x
							P\Y = Knot\Y + y
							
							P\Dis = Abs((P\X - DestinationX) * 10)+ Abs((P\Y - DestinationY) * 10)
							P\Attr = P\Dis + P\F
							
							P\parent = Knot
							
						Else
							
							k = Object.TPathKnots(KnotOnPos(Knot\X + x,Knot\Y + y))
							If k\done = 0 Then
								Local tF
								If (x= -1 Or x=1) And y=0 Then
									tF = 10
								ElseIf (y= -1 Or y=1) And x=0 Then
									tF = 10
								Else
									tF = 14
								EndIf
								
								If tF > k\parent\F Then
									k\parent =  Knot
									k\F = tF
									k\Dis = Abs((k\X - DestinationX) * 10)+ Abs((k\Y - DestinationY) * 10)
								EndIf
							Else 
								Error=Error+1
							EndIf
						EndIf
					EndIf
					jump=0
				EndIf
			Next
		Next
		
		If Error = 8 Then Return 0
		
	Until (Knot\X = DestinationX) And (Knot\Y = DestinationY)
	
	For Knot.TPathKnots = Each TPathKnots
		If Knot\done = 0 Then FreeEntity Knot\piv : Delete Knot
	Next
	
End Function

Function UpdatePathfinding(PosX%,PosY%)
	Local temp = KnotOnPos(PosX,PosY)
	Local asdf
	Local milli=MilliSecs()
	;For kn1.TPathKnots = Each TPathKnots
	;	kn1\parent = Before kn1
	;Next
	
	If temp > 0 Then
		Local knot1.TPathKnots = Object.TPathKnots(temp)
		Local knot2.TPathKnots = After knot1
		Local StartKnot.TPathKnots = knot1\parent
		FreeEntity knot1\piv
		
		Local x,y
		
	;	For x = -1 To 1
	;		For y = -1 To 1
	;			temp=KnotOnPos(PosX+x,PosY+y)
	;			If temp>0 And GetMap(PosX+x,PosY+y) Then 
	;				Local taep.TPathKnots= Object.TPathKnots(temp)
	;				Local taep2.TPathKnots = After taep;GetParentP.TPathKnots(taep) 
	;				taep2\parent = taep\parent
	;				;Delete taep
	;			EndIf
	;		Next
	;	Next
		
		;.back
		Local StartX = StartKnot\X
		Local StartY = StartKnot\Y
		
		Local DestinationX = knot2\X
		Local DestinationY = knot2\Y
		
		Local knot.TPathKnotsUpdate
		For knot = Each TPathKnotsUpdate
			Delete knot
		Next
		
		;Delete knot1\parent\parent
		;Delete knot1\parent
		Delete knot1
		
		
		
		knot.TPathKnotsUpdate = New TPathKnotsUpdate
		knot\X =	StartX
		knot\Y = 	StartY
		knot\Attr = 2^30
		;knot\piv = CreatePivot()
		
		
		Repeat
			Local Error%=0
			
			Local k.TPathKnotsUpdate
			knot = First TPathKnotsUpdate
			
			For k = Each TPathKnotsUpdate
				If k\Attr <= knot\Attr And  k\done = 0 Then knot = k
			Next
			
			knot\done = 1
			
			If knot\X = DestinationX And knot\Y = DestinationY
				k.TPathKnotsUpdate = Last TPathKnotsUpdate
				
				Repeat
					k\done = 2
					k=k\parent
					
				Until k\X = StartX And k\Y = StartY
				
				For knot.TPathKnotsUpdate = Each TPathKnotsUpdate
					If knot\done <> 2 Then Delete knot
				Next
				
				
				Local tempK.TPathKnots = StartKnot
				
				For knot.TPathKnotsUpdate = Each TPathKnotsUpdate
					knot1.TPathKnots = New TPathKnots
					knot1\X=knot\X
					knot1\Y=knot\Y
					knot1\Attr=knot\Attr
					knot1\Dis=knot\Dis
					knot1\done=knot\done
					knot1\F = knot\F
					knot1\parent = tempK
					
					If DEBUG_PATHFINDING Then 
						knot1\piv = CreateCone()
					Else
						knot1\piv = CreatePivot()
					EndIf
					
					PositionEntity knot1\piv,knot\X,0,knot\Y
					
					Insert knot1 After tempK
					tempK = knot1
				Next
				knot2\parent=tempK
				
				
				Return 1
			EndIf
			
			
			Local jump
			For x = -1 To 1
				For y = -1 To 1
					If (Not(x=0 And y=0)) And (MMap(70+knot\X + x,70+knot\Y + y) =0) Then
						If x = 1 And y = 1 Then
							If (MMap(70+knot\X + 1,70+knot\Y + 0) = 1) Or (MMap(70+knot\X + 0,70+knot\Y - 1) =1) 
								jump = 1
							EndIf
						ElseIf x = -1 And y = -1 Then
							If (MMap(70+knot\X - 1,70+knot\Y + 0) =1) Or (MMap(70+knot\X + 0,70+knot\Y - 1) =1) 
								jump = 1
							EndIf
						ElseIf x = 1 And y = -1 Then
							If (MMap(70+knot\X ,70+knot\Y - 1) =1) Or (MMap(70+knot\X + 1,70+knot\Y ) =1) 
								jump = 1
							EndIf
						ElseIf x = -1 And y = 1 Then
							If (MMap(70+knot\X-1 ,70+knot\Y ) =1) Or (MMap(70+knot\X,70+knot\Y+1 ) =1) 
								jump = 1
							EndIf
						EndIf
						If jump=0 Then
							If KnotOnPosUpdate(knot\X + x,knot\Y + y) = 0 Then
								
								Local P.TPathKnotsUpdate = New TPathKnotsUpdate
								
								If (x= -1 Or x=1) And y=0 Then
									P\F = 10
								ElseIf (y= -1 Or y=1) And x=0 Then
									P\F = 10
								Else
									P\F = 14
								EndIf
								P\X = knot\X + x
								P\Y = knot\Y + y
								
								P\Dis = Abs((P\X - DestinationX) * 10)+ Abs((P\Y - DestinationY) * 10)
								P\Attr = P\Dis + P\F
								
								P\parent = knot
								
							Else
								
								k = Object.TPathKnotsUpdate(KnotOnPosUpdate(knot\X + x,knot\Y + y))
								If k\done = 0 Then
									Local tF
									If (x= -1 Or x=1) And y=0 Then
										tF = 10
									ElseIf (y= -1 Or y=1) And x=0 Then
										tF = 10
									Else
										tF = 14
									EndIf
									
									If tF > k\parent\F Then
										k\parent =  knot
										k\F = tF
										k\Dis = Abs((k\X - DestinationX) * 10)+ Abs((k\Y - DestinationY) * 10)
									EndIf
								Else 
									Error=Error+1
								EndIf
							EndIf
						EndIf
						jump=0
					EndIf
				Next
			Next
			
			If MilliSecs()-milli>1000 Then
				DeletePath()
				PathCheck(40,50,0,-50)
				pathupdated=1
				
				
				Return
			EndIf
			If Error = 8 Then 
				knot2 = After knot2
				RuntimeError("asd");Goto back
			EndIf
		Until (knot\X = DestinationX) And (knot\Y = DestinationY)
		
		
	EndIf
End Function
;~IDEal Editor Parameters:
;~C#Blitz3D