
Global editor_selected.tile
Global editor_yoff=60

Global editor_MouseCheck

Dim editor_tempmap.tile(1,1)

Function Editor()
	Local off_x,off_y
	
	If Not MouseDown(1) Then editor_MouseCheck=True
	
	;Map
	Local Enter=KeyHit(28)
	Local Del=KeyDown(211)
	Color 255,0,0
	TileBlock gras,-scroll_x,-scroll_y
	For y=0 To map_h-1
		For x=0 To map_w-1
			If map(x,y)<>Null Then
				DrawBlock map(x,y)\img,(x*tile_size)-scroll_x,(y*tile_size)-scroll_y+editor_yoff
			EndIf
			If ctrl_my>y*tile_size+editor_yoff-scroll_y And ctrl_my<y*tile_size+tile_size+editor_yoff-scroll_y Then
				If ctrl_mx>x*tile_size-scroll_x And ctrl_mx<x*tile_size+tile_size-scroll_x Then
					Rect x*tile_size-scroll_x,y*tile_size+editor_yoff-scroll_y,tile_size,tile_size,0
					If ctrl_my>editor_yoff Then
						If MouseDown(1) And editor_MouseCheck Then
							map(x,y)=editor_selected
						EndIf
						If MouseDown(2) Or Del Then
							map(x,y)=Null
							If x=map_start_x And y=map_start_y Then
								map_start_x=-1
							EndIf
						EndIf
						If Enter Then
							If map(x,y)<>Null Then
								If map(x,y)\dir1[0]=OtherDirection(map(x,y)\dir1[1]) And map(x,y)\dir2[0]=0 Then
									map_start_x=x
									map_start_y=y
								EndIf
							EndIf
						EndIf
					EndIf
				EndIf
			EndIf
		Next
	Next
	
	If map_start_x<>-1 Then
		Color 0,0,255
		Rect map_start_x*tile_size-scroll_x,map_start_y*tile_size-scroll_y+editor_yoff,tile_size,tile_size,0
		off_x=tile_size/2-scroll_x
		off_y=tile_size/2-scroll_y+editor_yoff
		Oval map_start_x*tile_size+off_x-5,map_start_y*tile_size+off_y-5,10,10,0
		Select map(map_start_x,map_start_y)\dir1[1]
			Case DIR_RIGHT
				Line map_start_x*tile_size+off_x,map_start_y*tile_size+off_y,map_start_x*tile_size+50+off_x,map_start_y*tile_size+off_y
			Case DIR_DOWN
				Line map_start_x*tile_size+off_x,map_start_y*tile_size+off_y,map_start_x*tile_size+off_x,map_start_y*tile_size+50+off_y
		End Select
	EndIf
	
	Color 0,0,0
	Rect 0,0,GWIDTH,editor_yoff,1
	Color 255,255,255
	Text GWIDTH-250,10,"H = Hilfe (Bedienungshinweise)"
	
	If map_start_x=-1 Then
		Text GWIDTH-250,30,"Noch keinen Startpunkt festgelegt!"
	EndIf
	
	If KeyDown(35) Then
		Color 0,0,0
		Rect GWIDTH/2-125,GHEIGHT/2-90,250,180,1
		Color 255,255,255
		Text GWIDTH/2,GHEIGHT/2-80,"L: Laden",1
		Text GWIDTH/2,GHEIGHT/2-60,"S: Speichern",1
		Text GWIDTH/2,GHEIGHT/2-40,"N: Neu",1
		Text GWIDTH/2,GHEIGHT/2-20,"Enter: Startpunkt setzen",1
		Text GWIDTH/2,GHEIGHT/2,"ESC: zum Hauptmenu",1
		Text GWIDTH/2,GHEIGHT/2+20,"Cursortasten: Map scrollen",1
		Text GWIDTH/2,GHEIGHT/2+40,"Entf: Tile lschen",1
		Text GWIDTH/2,GHEIGHT/2+60,"Leertaste: Map zurechtschneiden",1
	EndIf
	
	;Optionen
	If KeyHit(31) And map_start_x<>-1 Then
		FlushKeys()
		SaveMap(Input("Dateinamen zum Speichern angeben: "))
		FlushKeys()
	EndIf
	
	If KeyHit(38) Then
		LoadTracks()
		gamemode=MODE_EDITORLOAD
	EndIf
	
	If KeyHit(49) Then
		Editor_NewMap()
	EndIf
	
	If KeyHit(57) Then
		off_x=map_w
		off_y=map_h
		max_w=0
		max_h=0
		For y=0 To map_h-1
			For x=0 To map_w-1
				If map(x,y)<>Null Then
					If x>max_w Then max_w=x
					If y>max_h Then max_h=y
					If x<off_x Then off_x=x
					If y<off_y Then off_y=y
				EndIf
			Next
		Next
		
		map_w=max_w-off_x+1
		map_h=max_h-off_y+1
		Dim editor_tempmap(map_w-1,map_h-1)
		For y=off_y To map_h-1+off_y
			For x=off_x To map_w-1+off_x
				editor_tempmap(x-off_x,y-off_y)=map(x,y)
			Next
		Next
		
		Dim map(map_w-1,map_h-1)
		For y=0 To map_h-1
			For x=0 To map_w-1
				map(x,y)=editor_tempmap(x,y)
			Next
		Next
		map_start_x=map_start_x-off_x
		map_start_y=map_start_y-off_y
	EndIf
	
	Local tile.tile
	;Tile-Vorschau
	x=0
	Color 255,0,0
	For tile=Each tile
		DrawBlock tile\prev,x*50,0
		If ctrl_my<50 Then
			If ctrl_mx>x*50 And ctrl_mx<x*50+50 Then
				Rect x*50,0,50,50,0
				If ctrl_mhit Then
					editor_selected=tile
				EndIf
			EndIf
		EndIf
		If editor_selected=tile Then Rect x*50,0,50,50,0
		x=x+1
	Next
	
	mspeed=MouseZSpeed()
	If mspeed>0 Then
		If editor_selected=Null Then editor_selected=First tile
		editor_selected=After editor_selected
		If editor_selected=Null Then editor_selected=First tile
	ElseIf mspeed<0 Then
		If editor_selected=Null Then editor_selected=First tile
		editor_selected=Before editor_selected
		If editor_selected=Null Then editor_selected=Last tile
	EndIf
	
	;Misc
	scroll_x=scroll_x+(KeyDown(205)-KeyDown(203))*20
	scroll_y=scroll_y+(KeyDown(208)-KeyDown(200))*20
	If scroll_x>map_w*tile_size-GWIDTH Then scroll_x=map_w*tile_size-GWIDTH
	If scroll_y>map_h*tile_size-GHEIGHT+editor_yoff Then scroll_y=map_h*tile_size-GHEIGHT+editor_yoff
	If scroll_x<0 Then scroll_x=0
	If scroll_y<0 Then scroll_y=0
	
End Function

Function SaveMap(file$)
	If Right(file$,4)<>".dat" Then file$=file$+".dat"
	Local writer=WriteFile("tracks\"+file$)
	WriteByte(writer,map_w)
	WriteByte(writer,map_h)
	WriteByte(writer,map_start_x)
	WriteByte(writer,map_start_y)
	
	For y=0 To map_h-1
		For x=0 To map_w-1
			If map(x,y)<>Null Then
				WriteByte(writer,map(x,y)\id)
			Else
				WriteByte(writer,-1)
			EndIf
		Next
	Next
	CloseFile writer
End Function

Function Editor_NewMap()
	Cls
	Repeat
		FlushKeys()
		map_w=Input("Breite der Map (2-255): ")
		map_h=Input("Hhe der Map (2-255): ")
		FlushKeys()
	Until map_w>1 And map_h>1 And map_w<256 And map_h<256
	Dim map(map_w,map_h)
	map_start_x=-1
End Function

;~IDEal Editor Parameters:
;~F#8#B1#C5
;~C#Blitz3D