AppTitle "Kellerkampf"
Graphics3D 640,480,32,2
SetBuffer BackBuffer()

SeedRnd MilliSecs()

ChangeDir("gfx")

;3D2D

Global licht=CreateLight()
RotateEntity licht,90,0,0

Global schatten=LoadTexture("schatten.png",1+64)

Global glanz=LoadTexture("glanz.png",1+64)
TextureBlend glanz,3

Global glas=LoadTexture("glas.png",2+64)

Global kampiv=CreatePivot()
Global kam=CreateCamera(kampiv)

Global mauspiv=CreatePivot()

Global boden=CreatePlane()
	EntityPickMode boden,2
Global bodentex=LoadTexture("boden.jpg",1)
	EntityTexture boden,bodentex
	ScaleTexture bodentex,16,16

Global ebene=LoadTexture("ebene.png",1+2+16+32);Ebene fr GUI

Global schriftkl=LoadFont("Courier New",14,1)
Global schriftkl2=LoadFont("Courier New",16,1)
Global schriftmt=LoadFont("Courier New",24,1)
Global schriftgr=LoadFont("Courier New",48,1)

;Bei berschneidung und Aktion SCHADEN

;Kollision Kugel:
;Radius vergleich KUGEL GEGNER

;3D2D

;ICH

Global ichpiv,ichobj,ichhand,ichhandhitl,ichhandhitr,ichhandbonel,ichhandboner

ichpiv=CreatePivot()
	EntityParent kampiv,ichpiv
	PointEntity kampiv,ichpiv
ichobj=LoadMesh("manneken.3ds",ichpiv)
	EntityType ichobj,1
	EntityRadius ichobj,0.5
	EntityTexture ichobj,schatten
ichhand=LoadAnimMesh("hand.b3d",ichobj)
	EntityTexture ichhand,schatten
	ExtractAnimSeq(ichhand,0,0);1	nichts
	ExtractAnimSeq(ichhand,1,1);2	Schusswaffe
	ExtractAnimSeq(ichhand,1,6);3	-abfeuern
	ExtractAnimSeq(ichhand,7,7);4	Boxstellung
	ExtractAnimSeq(ichhand,8,13);5	-links
	ExtractAnimSeq(ichhand,14,19);6	-rechts
	ExtractAnimSeq(ichhand,20,20);7	Knppel
	ExtractAnimSeq(ichhand,21,32);8	-schlagen
ichhandboner=FindChild(ichhand,"arm.r")
	ichhandhitr=LoadMesh("handhit.3ds",ichhandboner)
	EntityAlpha ichhandhitr,0 ; 0 !!!
ichhandbonel=FindChild(ichhand,"arm.l")
	ichhandhitl=CopyEntity(ichhandhitr,ichhandbonel)

;;Allgemein
;Leben(Maximal und jetzt im Moment)
;Attacke (fr Schadensberechnung ICH->Gegner)
;Verteidigung (fr Schadensberechnung Gegner->ICH)
;Last (tragbares Gewicht OHNE Geschwindigkeitsverlust
;Geschwindigkeit Pro MS * MS Differenz (Errechnet aus (5-(ICHLast - Last(Inventar))/2000)/3.6/1000)
;ichwaffe (0,1 oder 2 fr Boxen, Knppel oder Pistole)
;ichknueppel (ID von der AUSGERSTETEN Knppelwaffe oder 0 bei keiner)
;ichpistole (ID von der AUSGERSTETEN Schusswaffe oder 0 bei keiner)
Global ichgeld=0
Global ichstufe=1,icherfahrung=0,icherfahrungstufe=100
Global ichlebenmax#=100,ichleben#=100
Global ichatt=10,ichver=10
Global ichlast=2000,ichgesch#,ichgewicht
Global ichwaffe=0,ichwaffesoll=0,ichknueppel=0,ichpistole=0


Global ichanim,ichanimalt,ichanims,ichanimt#,ichaniml,ichschuss,ichzeiteffekt#;Animation,alternative Animation,Sequenz,Zeit,Lnge,wurde geschossen, Animation

;;;ICH
;;3D
;-Pivot			Halter
;--Mesh			Objekt
;---Accesoirs	Hut, Augen usw.
;---Hnde		Hnde (Animationstrger)
;----Hitbox		fr Faustkampf
;----Bewaffnung	Knppel
;-----Hitbox	fr Knppelkampf
;--Kamera
;;VARIABLEN
;-Leben
;-Ausdauer
;-Waffenart
;-WaffenID
;-Munition
;-

;ICH

;BEUTEL

Global gbeutel=LoadAnimMesh("beutel.b3d")
	Global gbeuteltex=LoadTexture("beutel.png",1+4)
	EntityTexture gbeutel,gbeuteltex
	Global gbeutelftex=LoadTexture("beutelfarbe.png",1)
	ScaleTexture gbeutelftex,1,1
	EntityTexture gbeutel,gbeutelftex,0,1
	Global gbeutelhit=LoadMesh("beutelhit.3ds",gbeutel)
	NameEntity gbeutelhit,"hit"
	EntityAlpha gbeutelhit,0
	EntityTexture gbeutel,schatten,0,2
	
	ExtractAnimSeq(gbeutel,0,16);0 Loop stehen
	ExtractAnimSeq(gbeutel,17,26);1 Loop laufen
	ExtractAnimSeq(gbeutel,27,33);2 Schaden
	ExtractAnimSeq(gbeutel,34,41);3 Angriff
	
Global gring=CreateMesh(gbeutel)
EntityFX gring,1
EntityBlend gring,1
gsurf=CreateSurface(gring)

v0=AddVertex(gsurf,-0.75,0.1,0.75,0,0)
v1=AddVertex(gsurf,0.75,0.1,0.75,1,0)
v2=AddVertex(gsurf,0.75,0.1,-0.75,1,1)
v3=AddVertex(gsurf,-0.75,0.1,-0.75,0,1)

AddTriangle(gsurf,v0,v1,v2)
AddTriangle(gsurf,v0,v2,v3)
	Global gringtex=LoadTexture("ring.png",1+4)
	NameEntity gring,"ring"
	EntityTexture gring,gringtex

HideEntity gbeutel


;BEUTEL

ChangeDir("..")

;SUPERGLOBAL

Global mx#,my#,md1,md2,mzs,mh1,mh2

Type waffe
	Field id,typ,name$;ID des Types, Typ - Knppel/Schussw. , Name
	Field mesh,textur,schatten;Mesh und Textur ID, Schattentyp
	Field stufe,wert;Ab wann ist es kaufbar, wie viel kostet es
	Field gewicht;Gewicht in Gramm
	Field schaden,effekt;Effekt: 0 - nichts | 1 - Wasser | 2 - Feuer
	Field animgesch#;Geschwindigkeit der Animation
	;KNPPEL
		Field hitbox;HitboxID
		Field ausdauer;Ausdauerabzug
		Field zabs#,yabs#;ZAbstand/YAbstand vom Mesh zur Hand
	;SCHUSSWAFFE
		Field magazinmax,magazin;Magazingre, momentane Gre ICH
		Field nachladen;Nachladezeit in MS
		Field schussgesch#;Geschwindigkeit des Schusses
		Field radius#,radiuskol#;Radius fr a) Kollision und b) fr das Sprite
		Field r,g,b;Farbwerte fr das Sprite
		Field sprite;SpriteID nach der angegeben Textur
		Field blend;Spriteblend
	Field info$[5];"Infobox"
	;ICH
	Field gekauft,anz;Wurde die Waffe bereits gekauft, anzeigen
End Type

Type schuss
	Field piv,sprite
	Field gesch#
	Field schaden,radius#
End Type

Type schatz_typ
	Field id,name$
	Field mesh,textur,schatten
	Field shade,blend
	Field wert
End Type

Global ersterschatz,letzterschatz

Type schatz
	Field id,sztid
	Field mesh
	Field wert
End Type

Type beutel
	Field mesh,hit,ring;Mesh und Ring
	Field animalt;alternative Animation
	Field maxleben,leben#;Leben
	Field panik,panikab;Soll Panik entstehen? Ab wie viel Leben (prozentual) flchten?
	Field inhalt;Anzahl der Gegenstnde
	Field typ,wahn,rache;0 bis zum Tod 1 bei wenig Leben Flucht 2 Flucht
	;Immer angreifen,Angreifen bei Angriff
	Field aktion,aktionzeit;Momentane Aktion,Zeit bis zur nchsten
	Field aktionflag,bezeiteffekt#
	;Beutel Aktionen: 0 dmpeln 1 Angriff 2 Panik
	Field attr#,panr#,dumr#;Attacken-,Panik- und Dmpelradius (wann was getan werden kann/soll)
	Field stufe,att,ver,ep
End Type

Type ebene
	Field mesh,x#,y#
	Field texto$,textu$;Text unten, oben
	Field alpha
End Type

Global wf.waffe,ss.schuss,szt.schatz_typ,sz.schatz,be.beutel,eb.ebene

Global timer=CreateTimer(58)

Global framemsalt=MilliSecs(),framems;Abstand zwischen den Frames in MS

Global zeiteffekt#=1,zeiteffektsrc#=0;Zeitvernderung

Global spielzeit=MilliSecs()+25000,spielwelle=1,spielmodus,spielshop
Global spielgegner,spielgegnermax=10

Global menutxt$[3]
menutxt[0]="Kellerkampf"
menutxt[1]="Spiel starten"
menutxt[2]="Gegner: "
menutxt[3]="Beenden"

;SUPERGLOBAL

ichknueppel=2
ichpistole=1

Global ebenen[2]

ebenen[0]=NeuEbene(6,102,"1.","Fuste")
ebenen[1]=NeuEbene(6,172,"2.","Knppel")
ebenen[2]=NeuEbene(6,242,"3.","Pistole")

EntityAlpha ebenen[1],0.1
EntityAlpha ebenen[2],0.1

LadeWaffen
LadeSchatz

menu

Function Menu()
	ende=0
	
	ClsColor 24,16,0
	Repeat
		WaitTimer timer
		Cls
		
		mx=MouseX()
		my=MouseY()
		mz=MouseZ()
		mzs=MouseZSpeed()
		mh1=MouseHit(1)
		mh2=MouseHit(2)
		
		SetFont schriftgr
		
		
		btext 320-StringWidth(menutxt[0])/2,48,menutxt[0],192,192,192,2
		
		If mx=>320-StringWidth(menutxt[0])/2 And mx=<320+StringWidth(menutxt[0])/2 And my=>150 And my=<150+48
			btext 320-StringWidth(menutxt[1])/2,150,menutxt[1],128,255,128,2
			If mh1
				spiel
			EndIf
		Else
			btext 320-StringWidth(menutxt[1])/2,150,menutxt[1],192,192,192,2
		EndIf
		
		If mx=>320-StringWidth(menutxt[0])/2 And mx=<320+StringWidth(menutxt[0])/2 And my=>250 And my=<250+48
			btext 320-StringWidth(menutxt[2]+spielgegnermax)/2,250,menutxt[2]+spielgegnermax,255,255,128,2
			If mh1 Or mh2
				addieren=mh1*5-mh2*5
				spielgegnermax=spielgegnermax+addieren
				If spielgegnermax<5
					spielgegnermax=5
				EndIf
			EndIf
		Else
			btext 320-StringWidth(menutxt[2]+spielgegnermax)/2,250,menutxt[2]+spielgegnermax,192,192,192,2
		EndIf
		
		If mx=>320-StringWidth(menutxt[3])/2 And mx=<320+StringWidth(menutxt[3])/2 And my=>350 And my=<350+48
			btext 320-StringWidth(menutxt[3])/2,350,menutxt[3],255,128,128,2
			If mh1
				End
			EndIf
		Else
			btext 320-StringWidth(menutxt[3])/2,350,menutxt[3],192,192,192,2
		EndIf
		
	SetFont schriftmt
	btext 25,450,"Kellerkampf  Fredkostudio - Frederik S. 2010",96,64,0,2
				
	Flip	
	Until KeyHit(1)
	End
End Function

Function Spiel()
ichgeld=0:ichstufe=1:icherfahrung=0:icherfahrungstufe=100:ichlebenmax#=100:ichleben#=100:ichatt=10:ichver=10:ichlast=2000:ichwaffe=0:ichwaffesoll=0
spielgegner=0
	Repeat
	WaitTimer timer
	Cls
		
		SpielKI
		
		zeiteffektsrc=zeiteffektsrc*0.95
		
		If zeiteffektsrc<0.01
			zeiteffektsrc=0
		ElseIf zeiteffektsrc>0.75
			zeiteffektsrc=0.75
		EndIf
		
		zeiteffekt=1.0-zeiteffektsrc
		
		mx=MouseX()
		my=MouseY()
		mz=MouseZ()
		mzs=MouseZSpeed()
		mh1=MouseHit(1)
		md1=MouseDown(1)
		
		framems=MilliSecs()-framemsalt
		framemsalt=MilliSecs()
		
		ichanim=Animating(ichhand)
		ichanims=AnimSeq(ichhand)
		ichanimt=AnimTime(ichhand)
		ichaniml=AnimLength(ichhand)
		
		IchAktion()
		UpdSchuss()
		AktionBeutel()
		UpdSchatz()
		IchEp()
		
		UpdateWorld
		RenderWorld
		
		Ebene2D
		
		SetFont schriftgr
		If spielmodus=0			
			btext 300,48,(spielzeit-MilliSecs())/1000,255,0,0,2
			btext 0,0,"Ebene "+spielwelle,255,0,0,2
			
			btext 0,440,"Geld: "+ichgeld+"f",255,192,0,2
			
			btext 380,400,"Leben: "+Int(ichleben),255,64,128,2
			btext 320,440,"Gewicht: "+ichgewicht/1000+"KG",64,64,64,2
			
			btext 640-StringWidth("Bentigte EP:"+(icherfahrungstufe-icherfahrung)),0,"Bentigte EP:"+(icherfahrungstufe-icherfahrung),0,0,255,2
			btext 640-StringWidth("Stufe: "+ichstufe),48,"Stufe: "+ichstufe,0,0,255,2
		ElseIf spielmodus=1
			btext 300,48,(spielshop-MilliSecs())/1000,255,0,0,2
			
			btext 300,220,"PAUSE",0,255,0,2
		EndIf
	Flip 0
	Until KeyHit(1) Or ichleben=<0
	FlushKeys()
	LoescheSchatz
	LoescheSchuss
	LoescheBeutel
End Function

Function SpielKI()
	If spielzeit-MilliSecs()=<0 And spielmodus=0
		ichleben=ichlebenmax
		LoescheSchatz
		LoescheSchuss
		LoescheBeutel
		
		spielmodus=1;Shop
		spielshop=MilliSecs()+5000
	EndIf
	
	If spielshop-MilliSecs()=<0 And spielmodus=1
		spielmodus=0;Kampf
		spielwelle=spielwelle+1
		spielzeit=MilliSecs()+25000
	EndIf
	
	If spielmodus=0 And spielzeit-MilliSecs()>0;Spiel
		For be=Each beutel
			If EntityDistance(be\mesh,ichobj)>35
				FreeEntity be\mesh
				
				Delete be
				spielgegner=spielgegner-1
			EndIf
		Next
		
		If spielgegner<spielgegnermax
			rad#=Rnd(5,10)
			grad=Rand(359)
			
			NeuBeutel(EntityX(ichobj)+Cos(grad)*rad,EntityZ(ichobj)+Sin(grad)*rad)
		EndIf
	EndIf
End Function

Function IchEp()
	If icherfahrung>=icherfahrungstufe
		ichstufe=ichstufe+1
		ichatt=ichatt*ichstufe
		ichver=ichver*ichstuffe
		ichlast=ichlast*ichstufe
		
		icherfahrungstufe=icherfahrungstufe*2.5
	EndIf
End Function

Function IchAktion()
	
	CameraPick kam,mx,my
	
	PositionEntity mauspiv,PickedX(),0,PickedZ()
		
	dy#=DeltaYaw(ichobj,mauspiv)/10
	TurnEntity ichobj,0,dy,0
	
	
	bewz=KeyDown(17)-KeyDown(31)
	
	bewx=-KeyDown(30)+KeyDown(32)
	
	ichgewicht=0
	
	If ichknueppel<>0
		wf=Object.waffe(ichknueppel)
		ichgewicht=ichgewicht+wf\gewicht
	EndIf
	
	If ichpistole<>0
		wf=Object.waffe(ichpistole)
		ichgewicht=ichgewicht+wf\gewicht
	EndIf
	
	ichgesch#=5+(ichlast-ichgewicht)/2000
	
	MoveEntity ichobj,bewx*(ichgesch/2/360.0)*framems*zeiteffekt,0,bewz*(ichgesch/360.0)*framems*zeiteffekt
	PositionEntity kampiv,EntityX(ichobj),10,EntityZ(ichobj)-6;KAMERA
	PointEntity kam,ichobj
	
	If mzs>0 And Animating(ichhand)=0
		ichwaffesoll=(ichwaffe-1+3)Mod 3
	ElseIf mzs<0
		ichwaffesoll=(ichwaffe+1)Mod 3
	EndIf
			
	If ichwaffesoll<>ichwaffe And ichanim=0 And ichanimalt=0
		Select ichwaffesoll
			Case 0
				EntityAlpha ebenen[ichwaffe],0.1
				
				wf=Object.waffe(ichknueppel)
						EntityAlpha wf\mesh,0
						wf\anz=0
				
				wf=Object.waffe(ichpistole)
						EntityAlpha wf\mesh,0
						wf\anz=0
				
				ichwaffe=0
				ichwaffesoll=0
				
				EntityAlpha ebenen[ichwaffe],1
			Case 1
				If ichknueppel>0
					EntityAlpha ebenen[ichwaffe],0.1
					
					If ichwaffe=2
						wf=Object.waffe(ichpistole)
							EntityAlpha wf\mesh,0
							wf\anz=0
					EndIf
					
					ichwaffe=1
					ichwaffesoll=1
					
					EntityAlpha ebenen[ichwaffe],1
				Else
					ichwaffesoll=ichwaffe
				EndIf
			Case 2
				If ichpistole>0
					EntityAlpha ebenen[ichwaffe],0.1
					
					If ichwaffe=1
						wf=Object.waffe(ichknueppel)
							EntityAlpha wf\mesh,0
							wf\anz=0
					EndIf
					
					ichwaffe=2
					ichwaffesoll=2
					
					EntityAlpha ebenen[ichwaffe],1
				Else
					ichwaffesoll=ichwaffe
				EndIf
		End Select
	EndIf
			
	Select ichwaffe
		Case 0;Faust
			If ichanims=4 And (mh1 Or md1)
				Animate ichhand,3,0.5*zeiteffekt,4+Rand(1,2)
				ichzeiteffekt=zeiteffekt
			ElseIf ichanim=0 And ichanims<>4 And ichanimalt=0
				Animate ichhand,3,1,4
			EndIf
		Case 1;Knppel
			wf=Object.waffe(ichknueppel)
			
			If wf\anz=0
				EntityAlpha wf\mesh,1
				wf\anz=1
			EndIf
			
			If ichanims=7 And (mh1 Or md1)
				Animate ichhand,3,wf\animgesch*zeiteffekt,8
				ichzeiteffekt=zeiteffekt
			ElseIf ichanim=0 And ichanims<>7 And ichanimalt=0
				Animate ichhand,3,1,7
			EndIf
		Case 2;Pistole
			wf=Object.waffe(ichpistole)
			
			If wf\anz=0
				EntityAlpha wf\mesh,1
				wf\anz=1
			EndIf
			
			If ichanims=2 And (mh1 Or md1)
				Animate ichhand,3,wf\animgesch*zeiteffekt,3
				ichzeiteffekt=zeiteffekt
				ichschuss=1
			ElseIf ichanim=0 And ichanims<>2 And ichanimalt=0
				Animate ichhand,3,1,2
			EndIf
	End Select
	
	If ichanims=5 Or ichanims=6 Or ichanims=8
		hit=0
		schaden=0
		
		If ichwaffe=1
			wf=Object.waffe(ichknueppel)
				hit=wf\hitbox
				schaden=wf\schaden
		ElseIf ichanims=5
			hit=ichhandhitl
			schaden=2
		ElseIf ichanims=6
			hit=ichhandhitr
			schaden=2
		EndIf
		
		For be=Each beutel
			If MeshesIntersect(hit,be\hit) And hit<>0
				If ((be\ver-ichatt)-100)/100.0*schaden<0
					be\leben=be\leben+((be\ver-ichatt)-100)/100.0*schaden
				 
					If be\rache
						be\aktion=1
					EndIf
					If AnimSeq(be\mesh)<3
						Animate be\mesh,3,0.5,3
					EndIf
				EndIf
			EndIf
		Next
	EndIf
	
	If ichanimalt
		If ichanimt+0.5*zeiteffekt<ichaniml
			animz#=0
			
			If ichwaffe=1
				wf=Object.waffe(ichknueppel)
					animz=wf\animgesch
			ElseIf ichwaffe=2
				wf=Object.waffe(ichpistole)
					animz=wf\animgesch
			Else
				animz=0.5
			EndIf
			
			SetAnimTime ichhand,ichanimt+animz*zeiteffekt,ichanims
		Else
			ichanimalt=0
		EndIf
	EndIf
		
	If (ichanims=5 Or ichanims=6 Or ichanims=8 Or ichanims=3) And ichzeiteffekt<>zeiteffekt
		;Wenn die letzte Animationsgeschwindigkeit unglauch der vorgegebenen ist, dies sofort beheben
		altzeit=ichanimt
		
		animz#=0
		
		If ichwaffe=1
			wf=Object.waffe(ichknueppel)
				animz=wf\animgesch
		ElseIf ichwaffe=2
			wf=Object.waffe(ichpistole)
				animz=wf\animgesch
		Else
			animz=0.5
		EndIf
		
		Animate ichhand,3,animz*zeiteffekt,ichanims
		SetAnimTime ichhand,ichanimt,ichanims
		
		ichanimalt=1
		
		ichzeiteffekt=zeiteffekt
	EndIf
	
	If ichschuss
		IchPistoleSchuss()
		ichschuss=0		
	EndIf
	
	If ichanims=8;Schlagen
	EndIf
End Function

Function IchPistoleSchuss()
	wf=Object.waffe(ichpistole)
	
	ss=New schuss
		ss\piv=CreatePivot(wf\mesh)
		EntityParent ss\piv,0
		ss\sprite=CopyEntity(wf\sprite,ss\piv)
		RotateEntity ss\piv,0,EntityYaw(ichobj),0
		
		ss\gesch=wf\schussgesch
		ss\schaden=wf\schaden
		ss\radius=wf\radiuskol
End Function

Function UpdSchuss()
	For ss=Each schuss
		MoveEntity ss\piv,0,0,ss\gesch
		
		del=0
		
		For be=Each beutel
			If EntityDistance(ss\piv,be\mesh)=<ss\radius
				be\leben=be\leben-ss\schaden

				del=1
			EndIf
		Next
		
		If del=1
			FreeEntity ss\piv
			Delete ss
		EndIf
	Next
End Function

Function LoescheSchuss()
	For ss=Each schuss
		FreeEntity ss\piv
		Delete ss
	Next
End Function

Function NeuBeutel(x#,z#)
	be=New beutel
		be\mesh=CopyEntity(gbeutel)
		be\hit=FindChild(be\mesh,"hit")
		be\ring=FindChild(be\mesh,"ring")
		
		ShowEntity be\mesh
		EntityType be\mesh,2
		EntityRadius be\mesh,0.5
		PositionEntity be\mesh,x,0,z
		RotateEntity be\mesh,0,180,0		
		be\maxleben=100
		be\leben=be\maxleben
		be\inhalt=Rand(1,5)
		be\typ=Rand(0,3)
		be\stufe=Rand(1,ichstufe)
		
		be\att=3
		be\ver=3
		
		For i=1 To be\stufe
			be\att=be\att*i+Rand(-5,5)
			be\ver=be\ver*i+Rand(-5,5)
		Next
		
		
		Select be\typ
			Case 0;Wahn
				be\wahn=1
				be\attr=5
				
				be\att=be\att+2
				
				EntityColor be\ring,255,0,0
			Case 1;Bse
				be\wahn=1
				be\attr=10
				
				be\att=be\att+1
				
				EntityColor be\ring,255,128,0
			Case 2;Notgedrungen
				be\rache=1
				be\panr=5
				be\panik=1
				be\panikab=0.25
				
				be\att=be\ver+1
				
				EntityColor be\ring,255,255,0
			Case 3;Angst
				be\panr=7.5
				be\panik=1
				be\panikab=0.5
				
				be\att=be\ver+2
				
				EntityColor be\ring,0,255,0				
		End Select
		
		be\ep=(be\att+be\ver)/be\stufe
		
		spielgegner=spielgegner+1
End Function

;Type beutel
;	Field mesh,ring;Mesh und Ring
;	Field animalt;alternative Animation
;	Field maxleben,leben;Leben
;	Field panik,panikab;Soll Panik entstehen? Ab wie viel Leben (prozentual) flchten?
;	Field inhalt;Anzahl der Gegenstnde
;	Field typ,wahn,rache;0 bis zum Tod 1 bei wenig Leben Flucht 2 Flucht
;	;Immer angreifen,Angreifen bei Angriff
;	Field aktion,aktionzeit;Momentane Aktion,Zeit bis zur nchsten
;	;Beutel Aktionen: 0 dmpeln 1 Angriff 2 Panik
;	Field attr#,panr#;Attacken-,Panikradius (wann was getan werden kann/soll)
;End Type


;	;Beutel Aktionen: 0 dmpeln 1 Angriff 2 Panik


Function AktionBeutel()
	;Beutel Aktionen: 0 dmpeln 1 Angriff 2 Panik
	For be=Each beutel
		dis#=EntityDistance(be\mesh,ichobj)
		
		bewz#=0
		
		dely#=DeltaYaw(be\mesh,ichobj)
		
		anim=1;Keine Laufbehindernde Animation(noch)
		
		Local beanim=(Animating(be\mesh) Or be\animalt),beanimt=AnimTime(be\mesh),beanims=AnimSeq(be\mesh),beaniml=AnimLength(be\mesh)
		
		If be\aktionzeit>MilliSecs() And be\aktion<>1
			If be\aktion=0
				bewz=be\aktionflag*0.25
			ElseIf be\aktion=2
				bewz=0.75
			EndIf
		ElseIf be\aktionzeit<MilliSecs() And be\aktion<>1
			If be\aktion=0
				TurnEntity be\mesh,0,Rand(-90,90),0
				be\aktionflag=Rand(0,1)
				be\aktionzeit=MilliSecs()+Rand(20,50)*100
			ElseIf be\aktion=2
				If dis<be\panr
					PointEntity be\mesh,ichobj
					TurnEntity be\mesh,0,180,0
					be\aktionzeit=MilliSecs()+Rand(10,20)*100
				Else
					be\aktion=0
					TurnEntity be\mesh,0,Rand(-90,90),0
					be\aktionzeit=MilliSecs()+Rand(20,50)*100				
				EndIf
			EndIf
		ElseIf be\aktion=1
			PointEntity be\mesh,ichobj
			bewz=1
		EndIf
		
		If be\wahn=1 And dis<be\attr
			be\aktion=1
		EndIf
		
		If be\panik=1 And (dis<be\panr Or be\leben<be\maxleben*be\panikab)
			be\aktion=2
			be\aktionzeit=MilliSecs()+Rand(10,20)*100
		EndIf
		
		If bewz>0 And (Animating(be\mesh)=0 Or beanims=1)
			Animate be\mesh,1,0.5*zeiteffekt,2
			be\bezeiteffekt=zeiteffekt
		ElseIf bewz=0 And beanims=2
			Animate be\mesh,2,0.5*zeiteffekt,1
			be\bezeiteffekt=zeiteffekt
		ElseIf dis<=1.5 And beanims<>4 And be\aktion=1
			If ((ichver-be\att)-100)/100.0*Rand(1,3)<0
				Animate be\mesh,3,0.5*zeiteffekt,4
				be\bezeiteffekt=zeiteffekt
				ichleben=ichleben+((ichver-be\att)-100)/100.0*Rand(1,3)
			EndIf
		EndIf
		
		If dis>1
			MoveEntity be\mesh,0,0,bewz*(4/360.0)*framems*zeiteffekt*anim
		EndIf
		
		beanim=(Animating(be\mesh) Or be\animalt):beanimt=AnimTime(be\mesh):beanims=AnimSeq(be\mesh):beaniml=AnimLength(be\mesh)
		
		If beanim And be\bezeiteffekt<>zeiteffekt
			be\bezeiteffekt=zeiteffekt
			be\animalt=1
		EndIf
		
		If be\animalt And beaniml>beanimt+0.5*zeiteffekt
			SetAnimTime be\mesh,beanimt+0.5*zeiteffekt,beanims
		Else
			be\animalt=0
		EndIf
		
		If be\leben<0
			NeuSchatz()
			
			FreeEntity be\mesh
			
			icherfahrung=icherfahrung+be\ep
			
			spielgegner=spielgegner-1
				
			Delete be
		EndIf
	Next	
End Function

Function LoescheBeutel()
	spielgegner=0
	
	For be=Each beutel
		FreeEntity be\mesh
		Delete be
	Next
End Function

Function NeuSchatz()
	inh=be\inhalt
	
	For i=0 To inh
		typ=Rand(ersterschatz,letzterschatz)
		szt=Object.schatz_typ(typ)
		
		sz=New schatz
			sz\id=Handle(sz)
			sz\sztid=sztyp
			sz\mesh=CopyEntity(szt\mesh,be\mesh)
			MoveEntity sz\mesh,Rnd(-1,1),0,Rnd(-1,1)
			EntityParent sz\mesh,0
			sz\wert=szt\wert
	Next
End Function

Function UpdSchatz()
	For sz=Each schatz
		TurnEntity sz\mesh,0,1,0
		
		If EntityDistance(ichobj,sz\mesh)<1
			ichgeld=ichgeld+sz\wert
			
			FreeEntity sz\mesh
			Delete sz
		EndIf
	Next
End Function

Function LoescheSchatz()
	For sz=Each schatz
		FreeEntity sz\mesh
		Delete sz
	Next
End Function

Function NeuEbene(x,y,texto$,textu$)
	eb=New ebene
		eb\mesh=CreateMesh(kam)
		EntityFX eb\mesh,1
		EntityOrder eb\mesh,-1
		EntityTexture eb\mesh,ebene
		
		surf=CreateSurface(eb\mesh)
		
		xy#=64*(1.0/320)

		
		v0=AddVertex(surf,0,0,0,0,0)
		v1=AddVertex(surf,xy,0,0,1,0)
		v2=AddVertex(surf,xy,-xy,0,1,1)
		v3=AddVertex(surf,0,-xy,0,0,1)
		
		AddTriangle(surf,v0,v1,v2)
		AddTriangle(surf,v0,v2,v3)
		
		eb\texto=texto
		eb\textu=textu
		
		eb\x=x
		eb\y=y
		
		PositionEntity eb\mesh,(320-x)/-320.0,(240-y)/320.0,1.00001
		
		Return eb\mesh
End Function

Function Ebene2D()
	For eb=Each ebene
		SetFont schriftkl
		Color 0,0,0
		Text eb\x+4,eb\y+4,eb\texto
		
		SetFont schriftkl2
		Text eb\x+(32-StringWidth(eb\textu)/2),eb\y+48,eb\textu
	Next
End Function

Function LadeWaffen()
	;;;Funktion zum Laden der Waffen
	;;Vorgehensweise: Alle Dateien nacheinander durchgehen. Dabei pro Datei dies tun:
	;Wenn Endung = ".kkwf" Dann durcharbeiten:
	;Typ suchen
	;Neue Instanz erstellen
	;Alles bis zu den Typspezifischen Werten speichern
	;Bei Typspezifisch: blo die bentigten Felder fllen
	;Rest
	;;Nchste Datei
	Local obj=ReadDir("obj")
		Repeat
		
			datei$=NextFile(obj)			
			If datei="";Keine Datei? Abbruch!
				Exit
			EndIf
			
			dateiendung$=Right(datei,4)
			If dateiendung="kkwf";Waffendatei
				dateiinh=ReadFile("obj/"+datei);Datei lesen
				
				DebugLog "Neue Waffe wird erstellt!"
				debug$="";String zum Debuggen
				wf=New waffe
					wf\id=Handle(wf)
					wf\typ=ReadLine(dateiinh)
					wf\name=ReadLine(dateiinh)
					meshpfad$="gfx/"+ReadLine(dateiinh)
					wf\mesh=LoadMesh(meshpfad,ichhandboner)
					
					If wf\typ=1
						PositionMesh wf\mesh,-0.1,0.05,0.3
						RotateMesh wf\mesh,-90,0,90
					EndIf
					
					;HideEntity wf\mesh
					texturepfad$=ReadLine(dateiinh)
					If texturepfad<>""
						wf\textur=LoadTexture("gfx/"+texturepfad)
						EntityTexture wf\mesh,wf\textur
					EndIf
					spieltex=ReadLine(dateiinh)
					wf\schatten=spieltex
					Select spieltex
						Case 1
							EntityTexture wf\mesh,schatten,0,1
						Case 2
							EntityTexture wf\mesh,glanz,0,1
					End Select
					wf\stufe=ReadLine(dateiinh)
					wf\wert=ReadLine(dateiinh)
					wf\gewicht=ReadLine(dateiinh)
					wf\schaden=ReadLine(dateiinh)
					wf\effekt=ReadLine(dateiinh)
					wf\animgesch=ReadLine(dateiinh)
					
					Select wf\typ
						Case 0;Knppel
							hitboxpfad$="gfx/"+ReadLine(dateiinh)
							wf\hitbox=LoadMesh(hitboxpfad,wf\mesh)
								EntityAlpha wf\hitbox,0 ;ALPHA
							wf\ausdauer=ReadLine(dateiinh)
							wf\zabs=ReadLine(dateiinh)
							wf\yabs=ReadLine(dateiinh)

								PositionMesh wf\mesh,0,wf\yabs,wf\zabs
								RotateMesh wf\mesh,-90,0,0
								PositionMesh wf\hitbox,0,wf\yabs,wf\zabs
								RotateMesh wf\hitbox,-90,0,0
								
								EntityAlpha wf\mesh,0
								EntityAlpha wf\hitbox,0								
						Case 1;Pistole
							wf\magazinmax=ReadLine(dateiinh)
							wf\magazin=wf\magazinmax
							wf\nachladen=ReadLine(dateiinh)
							wf\schussgesch=ReadLine(dateiinh)
							wf\radius=ReadLine(dateiinh)
							wf\radiuskol=ReadLine(dateiinh)
							wf\r=ReadLine(dateiinh)
							wf\g=ReadLine(dateiinh)
							wf\b=ReadLine(dateiinh)
							spritepfad$="gfx/"+ReadLine(dateiinh)
							wf\sprite=LoadSprite(spritepfad)
							wf\blend=ReadLine(dateiinh)
							EntityType wf\sprite,2 ;KOLLISION
							EntityBlend wf\sprite,wf\blend
							EntityColor wf\sprite,wf\r,wf\g,wf\b
							ScaleSprite wf\sprite,wf\radius,wf\radius
							
							HideEntity wf\sprite
							EntityAlpha wf\mesh,0
					End Select
					
					wf\gekauft=1
						
				CloseFile(dateiinh)
			EndIf
			
		Until datei=""		
	CloseDir(obj)
End Function

Function LadeSchatz()
	;;;Funktion zum Laden der Schtze
	;;Vorgehensweise: Alle Dateien nacheinander durchgehen. Dabei pro Datei dies tun:
	;Wenn Endung = ".kksz" Dann durcharbeiten:
	;Typ suchen
	;Neue Instanz erstellen
	;Alles bis zu den Typspezifischen Werten speichern
	;Bei Typspezifisch: blo die bentigten Felder fllen
	;Rest	
	;;Nchste Datei
	
	Local count=0
	
	Local obj=ReadDir("obj")
		Repeat
		
			datei$=NextFile(obj)			
			If datei="";Keine Datei? Abbruch!
				Exit
			EndIf
			
			dateiendung$=Right(datei,4)
			If dateiendung="kksz";Waffendatei
				dateiinh=ReadFile("obj/"+datei);Datei lesen
				
				DebugLog "Neuer Schatztyp wird erstellt!"
				
				szt=New schatz_typ
					szt\id=Handle(szt)
						szt\name=ReadLine(dateiinh)
						meshpfad$="gfx/"+ReadLine(dateiinh)
						szt\mesh=LoadMesh(meshpfad)
						texturpfad$=ReadLine(dateiinh)
						If texturpfad<>""
							szt\textur=LoadTexture("gfx/"+texturpfad)
							EntityTexture szt\mesh,szt\textur
						EndIf
						rot=ReadLine(dateiinh)
						grun=ReadLine(dateiinh)
						blau=ReadLine(dateiinh)
						EntityColor szt\mesh,rot,grun,blau
						szt\schatten=ReadLine(dateiinh)
						Select szt\schatten						
							Case 1;Schatten
								EntityTexture szt\mesh,schatten,0,1
							Case 2;Glanz
								EntityTexture szt\mesh,glanz,0,1
							Case 3;Glas
								EntityTexture szt\mesh,glas,0,0
						End Select
						szt\blend=ReadLine(dateiinh)
						EntityBlend szt\mesh,szt\blend
						szt\shade=ReadLine(dateiinh)
						If szt\shade<>0
							EntityFX szt\mesh,4
						EndIf
						szt\wert=ReadLine(dateiinh)							
						
						HideEntity szt\mesh
						
						If count=0
							ersterschatz=Handle(szt)
						Else						
							letzterschatz=Handle(szt)
						EndIf
				CloseFile(dateiinh)
				count=count+1				
			EndIf
			
		Until datei=""
	CloseDir(obj)
End Function

Function btext(x,y,txt$,r,g,b,bor)
	Color 0,0,0
	For ya=-bor To bor
		For xa=-bor To bor
			Text x+xa,y+ya,txt
		Next
	Next
	
	Color r,g,b
	Text x,y,txt
End Function