AppTitle "Hexentanz"

Graphics 1024,768,0,1

SetBuffer BackBuffer()

SeedRnd MilliSecs()

Include "Includes\Vorlagen.bb"
Include "Includes\SetFunktionen.bb"
Include "Includes\Bewegung.bb"


;###Deklarationen###

Global FTimer =CreateTimer(60) ;Frametimer

Global Schriftart = LoadFont("Arial", 20)
Global SchriftGross = LoadFont("Arial", 40, 1, 0, 1)
SetFont Schriftart

Dim SpielerHut(5)
Dim SpielerK(6)
;BILDER
AutoMidHandle 1
;LevelBilder
Global ZaunM1 = LoadImage("gfx\Level\Zaun mitte 1.png")
MaskImage ZaunM1, 255, 255, 255
Global ZaunM2 = LoadImage("gfx\Level\blubbel.png")
MaskImage ZaunM2, 255, 255, 255
Global Wiese = LoadImage("gfx\Level\Wiese.png")
MaskImage Wiese, 255, 255, 255
Global Himmel = LoadImage("gfx\Himmel.png")


For i = 1 To 4
	SpielerHut(i) = LoadImage("Hte\Hut"+i+".PNG")
	MaskImage SpielerHut(i), 255,255,255
	ScaleImage SpielerHut(i), 0.5, 0.5
Next
For i = 1 To 5
	SpielerK(i) = LoadImage("Krbisse\Krbiss"+i+".png")
	MaskImage SpielerK(i), 255, 255, 255
	ScaleImage SpielerK(i), 0.5, 0.5
Next

Global Blitz = LoadAnimImage("gfx\BlitzAnim2.png", 32, 21, 0, 4)
ScaleImage Blitz, 2.1,2.1
Global WasserBall = LoadAnimImage("gfx\TropfenAnim.png", 64, 64, 0, 4)
MaskImage WasserBall, 255, 255, 255
Global FireBall = LoadAnimImage("gfx\FeuerballAnim.png", 64, 64, 0, 4)
MaskImage FireBall, 255, 255, 255
Global PlasmaBall = LoadAnimImage("gfx\PlasmaAnim.png", 64, 64, 0, 2)
MaskImage PlasmaBall, 255, 255, 255
ScaleImage PlasmaBall, 0.7, 0.7
Global BonBon = LoadAnimImage("gfx\BonBonAnim.png", 64, 64, 0, 2)
MaskImage BonBon, 255, 255, 255
ScaleImage BonBon, 0.7, 0.7



;Global Drache = LoadAnimImage("gfx\DracheAnim2.png", 128, 128, 0, 7)
Global Drache = LoadAnimImage("gfx\MesserAnim.png", 256, 64, 0, 3)
ScaleImage Drache, 0.6, 0.6
MaskImage Drache, 255, 255, 255
Global Gargoyle = LoadAnimImage("gfx\KerzeAnim.png", 128, 64, 0, 2)
Global Gegner3 = LoadAnimImage("gfx\AxtAnim.png", 64, 128, 0, 2)
MaskImage Gargoyle, 255, 255, 255
MaskImage Gegner3, 255, 255, 255
;MaskImage Drache, 4,2,4
Global GegnerSchuss3 = LoadImage("gfx\Pflock.png")
MaskImage GegnerSchuss3, 255, 255, 255
ScaleImage GegnerSchuss3, 1.2, 1.2
Global MesserShoot = LoadAnimImage("gfx\MesserShoot.png", 64, 64, 0, 2)
MaskImage MesserShoot, 255, 255, 255
Global Feuerball = LoadAnimImage("gfx\FeuerballAnim2.png", 64, 32, 0, 2)
;ScaleImage Feuerball, 1.2, 1.2
Global Suppe = LoadAnimImage("gfx\SuppeAnim.png", 64, 64, 0, 2)
MaskImage Suppe, 255, 255, 255
ScaleImage Suppe, 0.7, 0.7
MaskImage Feuerball, 255, 255, 255
Global Loeffel = LoadAnimImage("gfx\LoeffelAnim.png", 128, 128, 0, 3)
MaskImage Loeffel, 255, 255, 255

Global GameOver = LoadImage("gfx\GameOver.png")
MaskImage GameOver, 255, 255, 255

Global Geld1 = LoadAnimImage("gfx\MuenzeAnim.png", 64, 64, 0, 2)
MaskImage Geld1, 255, 255, 255
ScaleImage Geld1, 0.7, 0.7

Global BWeiter = LoadImage("gfx\BWeiter.png")
MaskImage BWeiter, 255, 255, 255
ScaleImage BWeiter, 0.5, 1
Global EnergieUp = LoadImage("gfx\EnergieUp.png")
MaskImage EnergieUp, 255, 255, 255
ScaleImage EnergieUp, 0.5, 1
Global SpeedUp = LoadImage("gfx\SpeedUp.png")
MaskImage SpeedUp, 255, 255, 255
ScaleImage SpeedUp, 0.5, 1
Global SchussUp = LoadImage("gfx\SchussUp.png")
MaskImage SchussUp, 255, 255, 255
ScaleImage SchussUp, 0.5, 1
Global Maus = LoadImage("gfx\Maus.png")
ScaleImage Maus, 1.2, 1.2
;/


Global Gravity# = 0.7

;Level:
Global Verschiebung#
Global SchiebNr = 0
Global Bild1, Bild2

Global LevelTime
Global LevelStart
;/


;Spieler:
Global PLevelUp = 0
Global PLevelUpTime = 1000
Global PLevelUpStart = 0
;/

;Gegner:
Global GegnerTimer = 2900
Global GegnerStart
;/

;Men:
Const State_Menue = 1
Const State_Start = 2
Const State_Shop = 3
Const State_End = 4
Const State_GameOver = 5
Global Game_State = State_Menue
Global Beenden = 0
;/


Global GameLevel = 1

;TYPES:
Type TPartikel
	Field XPos#, YPos#, Winkel#, Speed#
	Field Rot, Gruen, Blau
	Field Lebensdauer#, Startzeit#
	Field Dead
	Field YSpeed#, XSpeed#
End Type

Type TUpgrade
	Field Kosten
	Field Nr
	Field ID
	Field Menge#
End Type

Type TGeld
	Field Image.TImage
	Field XPos#, YPos#
	Field Dead
	Field Menge#
	Field Speed#
End Type

Type TImage
	Field Image
	Field Frame, MaxFrame
	Field FrameTimer, FrameStart
End Type

Type TSpieler
	Field XPos#, YPos#, Speed#
	Field SchussLevel
	Field Energie#
	Field SchussTimer, SchussStart
	Field FrameTimer, FrameStart, Frame
	Field Image, Image2
	Field VolleEnergie#
	Field Erfahrung#, Level
	Field Geld#
	Field BigTime, BigTimeStart
End Type

Type TSchussSpieler
	Field XPos#, YPos#, Speed#
	Field ID
	Field Kraft#
	Field Image.TImage
	Field Dead
End Type

Type TSchussGegner
	Field XPos#, YPos#, Speed#, Kraft
	Field Image.TImage
	Field Dead
End Type

Type TGegner
	Field XPos#, YPos#, Speed#
	Field SchussTimer, SchussStart
	Field Image.TImage
	Field Dead
	Field Erfahrung, Level
	Field Energie#
	Field ID
End Type
;/


;Vorlagen erstellen:
Global VorlageGegner.TVorlageGegner
EnemyVorlagen()
Global VorlageSchussGegner.TVorlageSchussGegner
EnemySchussVorlagen()
Global VorlageSchussSpieler.TVorlageSchussSpieler
PlayerSchussVorlagen()
Global VorlageGeld.TVorlageGeld
GeldVorlage()
Global VorlageUpgrade.TVorlageUpgrade
UpgradeVorlage()
SetUpgrades()
;/


;Neuer Spieler:
Global Spieler.TSpieler
Spieler.TSpieler = New TSpieler
Spieler\XPos# = 100
Spieler\YPos# = GraphicsHeight()/2
Spieler\Speed# = 5.0
Spieler\SchussTimer = 400
Spieler\SchussStart = MilliSecs()
Spieler\Image = SpielerHut(1)
Spieler\Image2 = SpielerK(1)
Spieler\Erfahrung# = 0
Spieler\SchussLevel = 1
Spieler\Level = 1
Spieler\Geld = 35
Spieler\VolleEnergie# = 100
Spieler\BigTime = 9999999999
Spieler\BigTimeStart = MilliSecs()
Spieler\Energie = Spieler\VolleEnergie
;/






Repeat
	WaitTimer(FTimer)
	Cls
	
Select Game_State
		
		
	Case 1 
	;Das "Men"
		
		DrawBlock Himmel, GraphicsWidth()/2, GraphicsHeight()/2
		DrawImage Wiese, GraphicsWidth()/2, GraphicsHeight()/2
		
		DrawImage Spieler\Image2, Spieler\XPos#, Spieler\YPos#+38
		DrawImage Spieler\Image, Spieler\XPos#, Spieler\YPos#
		
		Text 10, 10, " "
		Text 100, 50, "Erfahrung: " +  Spieler\Erfahrung + " / " + (100*(Spieler\Level/1.7))
		Text 100, 100, "Level: " + Spieler\Level
		Text 300, 50, "Geld : " + Spieler\Geld
		Text 220, 100, "Energie: " + Spieler\Energie
		Text 512, 384, "Enter drcken zum Starten", 1, 1
		
		If KeyDown(28) Then
			
			LevelStart = MilliSecs()
			LevelTime = 60000
			GegnerStart = MilliSecs()
			Game_State = State_Start
			
		EndIf
	;/
		
		
	Case 2
	;Das Spiel selbst
		
		
		If ((LevelStart + LevelTime) < MilliSecs()) Then ;In den Shop wechseln, wenn die Zeit um ist.
			
			;Alles einrichten:
			Delete  Each TSchussGegner
			
			Delete Each TSchussSpieler
				
			Delete Each TGeld
				
			Delete Each TPartikel
				
			Delete Each TGegner
			
			GameLevel = GameLevel + 1
			Verschiebung# = 0
			SchiebNr = 0
			Spieler\Energie = Spieler\VolleEnergie
			Game_State = State_Shop
			;/
			
		EndIf;/
		
		;Funktionen aufrufen:
		SpielerSteuerung()
		If ((GegnerStart + GegnerTimer) < MilliSecs()) Then
			SetEnemy(GameLevel)
		EndIf
		MoveShoot()
		MoveEnemy()
		Kollision()
		MoveGeld()
		MovePartikel()
		SpielerErfahrung()
		DrawLevel()
		AllesZeichnen()
		;/
		
		;berprfen ob der Spieler nicht schon tot ist:
		If Spieler\Energie <= 0 Then
			;wenn ja dann alle Type Eintrge lschen:
			Delete Spieler.TSpieler
			Delete Each TGegner
			Delete Each TSchussGegner
			Delete Each TSchussSpieler
			Delete Each TGeld
			;/
			;Alles auf Anfang:
			Verschiebung# = 0
			SchiebNr = 0
			Game_State = State_GameOver
			Delay 300
			;/
		EndIf
		;/
		
		If KeyDown(1) Then Game_State = State_End ;Das Spiel beenden
	;/
		
		
	Case 3
	;Das ShopMen
		Local kh = MouseHit(1) ;Variable damit Mousehit funktioniert
		
		;Die Buttons:
		DrawImage BWeiter, GraphicsWidth()/2, GraphicsHeight()-100
		DrawImage SchussUp, 150, 400
		DrawImage SpeedUp, 150, 100
		DrawImage EnergieUp, 650, 100
		;
		
		;Infos ber Upgrades etc:
		Text 10, 10, " "
		Color 250, 10, 10
		Text GraphicsWidth()/2-30, 50, "Dein Geld: " + Spieler\Geld, 1, 1
		Color 10, 250, 10
		
		
		For UpGrade.TUpgrade = Each TUpgrade
			If UpGrade\ID = 1 Then
				Text 150, 220, "Upgrade:Speed", 1, 1
				
				If Upgrade\Nr < 20 Then
					Text 150, 280, "UpgradeNR: " + Upgrade\Nr, 1, 1
					Text 150, 250, "Kosten: "+Upgrade\Kosten, 1 ,1
				Else
					Text 150, 280, "UpgradeNR: MAX (20)", 1, 1
					Text 150, 250, "Kosten: %", 1 ,1
				EndIf
			EndIf
			
			If Upgrade\ID = 2 Then
				Text 150, 520, "Upgrade: Schusslevel (Jedes Level bringt einen neuen Schusstypen)", 0,1
				
				If Upgrade\Nr < 4 Then
					Text 150, 580, "UpgradeNr: " +Upgrade\Nr,1, 1
					Text 150, 550, "Kosten: " + Upgrade\Kosten, 1,1
				Else
					Text 150, 580, "UpgradeNr: MAX (4)",1, 1
					Text 150, 550, "Kosten: %", 1,1
				EndIf
			EndIf
			
			If Upgrade\ID = 3 Then
				Text 650, 220, "Upgrade: Energie", 1, 1
				Text 650, 250, "Kosten: " + Upgrade\Kosten, 1, 1
				Text 650, 280, "UpgradeNr: "+Upgrade\Nr, 1, 1
			EndIf
		Next
		;/
		
		DrawImage Maus, MouseX(), MouseY() ;Maus zeichnen
		
		UpgradeAbfrage(kh)
		
		;Abfrage um das nchste Level zu starten:
		If kh And ImageRectCollide(BWeiter, GraphicsWidth()/2, GraphicsHeight()-100, 0, MouseX()-10, MouseY()-10, 20, 20) Then
			kh = 0
			;Alles frs nchste Level einrichten:
			LevelStart = MilliSecs()
			LevelTime = 60000
			GegnerStart = MilliSecs()
			Spieler\BigTimeStart = MilliSecs()
			Spieler\SchussStart = MilliSecs()
			;/
			Game_State = State_Start
			MoveMouse GraphicsWidth()/2, GraphicsHeight()/2
		EndIf
		;/
		
		If KeyDown(1) Then Game_State = State_End
	;/	
		
		
	Case 4
	;Spiel Beenden
		Beenden = 1
	;/
		
		
	Case 5
	;Der Game-Over Bildschirm
		
		Local kh2 = MouseHit(1)
		
		DrawImage GameOver, GraphicsWidth()/2, GraphicsHeight()/2
		
		
		DrawImage BWeiter, GraphicsWidth()/2, GraphicsHeight()-50
		DrawImage Maus, MouseX(), MouseY()
		
		;Abfrage ob man neu anfangen will:
		If kh2 And ImageRectCollide(BWeiter, GraphicsWidth()/2, GraphicsHeight()-50, 0, MouseX()-10, MouseY()-10, 20, 20) Then
			
			Game_State = State_Menue
			;Alles auf Anfang und neuer SpielerType:
			GameLevel = 1
			
			Delete Each TUpgrade
			SetUpgrades()
			
			Spieler.TSpieler = New TSpieler
			Spieler\XPos# = 100
			Spieler\YPos# = GraphicsHeight()/2
			Spieler\Speed# = 5.0
			Spieler\SchussTimer = 400
			Spieler\SchussStart = MilliSecs()
			Spieler\Image = SpielerHut(1)
			Spieler\Image2 = SpielerK(1)
			Spieler\Erfahrung# = 0
			Spieler\SchussLevel = 1
			Spieler\Level = 1
			Spieler\VolleEnergie = 100
			Spieler\Geld = 35
			Spieler\BigTime = 9999999999
			Spieler\BigTimeStart = MilliSecs()
			Spieler\Energie = Spieler\VolleEnergie
			;/
		EndIf
		
		If KeyDown(1) Then Game_State = State_End
		
End Select

	Flip 0

Until Beenden = 1



;###Funktionen###

;Gegner, Spieler etc zeichen:
Function AllesZeichnen()
	
	DrawImage Spieler\Image2, Spieler\XPos#, Spieler\YPos#+36.5
	DrawImage Spieler\Image, Spieler\XPos#, Spieler\YPos#
	
	;Rect Spieler\XPos#-28, Spieler\YPos#-28, 58, 80, 0
	
	For Geld.TGeld = Each TGeld
		DrawImage Geld\Image\Image, Geld\XPos#, Geld\YPos#, Geld\Image\Frame
		;Rect Geld\XPos#-(ImageWidth(Geld\Image\Image)/4), Geld\YPos#-(ImageHeight(Geld\Image\Image)/4), ImageWidth(Geld\Image\Image)/2, ImageHeight(Geld\Image\Image)/2, 0
	Next
	
	For Schuss.TSchussSpieler = Each TSchussSpieler
		DrawImage Schuss\Image\Image, Schuss\XPos#, Schuss\YPos#, Schuss\Image\Frame
		;Rect Schuss\XPos#-(ImageWidth(Schuss\Image\Image)/4), Schuss\YPos#-(ImageHeight(Schuss\Image\Image)/4), ImageWidth(Schuss\Image\Image)/2, ImageHeight(Schuss\Image\Image)/2, 0
;		Color 250, 10, 10
;		Text Schuss\XPos#, Schuss\YPos#-20, Schuss\Kraft#, 1, 1
;		Color 10, 250 ,10
	Next
	
	
	
	For SchussGegner.TSchussGegner = Each TSchussGegner
		DrawImage SchussGegner\Image\Image, SchussGegner\XPos#, SchussGegner\YPos#, SchussGegner\Image\Frame
		;Rect SchussGegner\XPos#-(ImageWidth(SchussGegner\Image\Image)/4), SchussGegner\YPos#-(ImageHeight(SchussGegner\Image\Image)/4), ImageWidth(SchussGegner\Image\Image)/2, ImageHeight(SchussGegner\Image\Image)/2, 0
	Next
	
	For Gegner.TGegner = Each TGegner
		DrawImage Gegner\Image\Image, Gegner\XPos#, Gegner\YPos#, Gegner\Image\Frame
		;Rect Gegner\XPos#-(ImageWidth(Gegner\Image\Image)/2.5), Gegner\YPos#-(ImageHeight(Gegner\Image\Image)/2.5), ImageWidth(Gegner\Image\Image)/1.3, ImageHeight(Gegner\Image\Image)/1.3, 0
;		Color 250, 10, 10
;		Text Gegner\XPos#, Gegner\YPos#-60, Gegner\Level, 1, 1
;		Text Gegner\XPos#, Gegner\YPos#+60, Gegner\Energie, 1, 1
;		Color 10, 250, 10
	Next
	
	For Partikel.TPartikel = Each TPartikel
		Color Partikel\Rot, Partikel\Gruen, Partikel\Blau
		Rect Partikel\XPos#, Partikel\YPos#, 2.6, 2.6, 1
	Next
	
	Color 255, 255, 255
	
	If ((PLevelUpStart + PLevelUpTime) > MilliSecs()) Then
		SetFont SchriftGross
		Color 250, 10, 10
		Text GraphicsWidth()/2, GraphicsHeight()/2, "Level Up", 1, 1
		SetFont Schriftart
		;Color 10, 250, 10
	EndIf
	
	Text 10, 10, " "
	Text 100, 50, "Erfahrung: " +  Spieler\Erfahrung + " / " + (100*(Spieler\Level/1.7))
	Text 100, 100, "Level: " + Spieler\Level
	Text 300, 50, "Geld : " + Spieler\Geld
	Text 220, 100, "Energie: " + Spieler\Energie
	
End Function
;/


;Upgrade Buttons abfragen:
Function UpgradeAbfrage(keyh)
	
	;Abfrage fr das Speed Upgrade:
	If keyh And ImagesOverlap(SpeedUp, 150, 100, Maus, MouseX(), MouseY()) Then
		For UpGrade.TUpgrade = Each TUpgrade
			If UpGrade\ID = 1 Then
				If Upgrade\Nr < 20 Then
					If Spieler\Geld >= UpGrade\Kosten Then
						Spieler\Speed# = Spieler\Speed# + UpGrade\Menge#
						Spieler\Geld = Spieler\Geld - Upgrade\Kosten
						UpGrade\Nr = UpGrade\Nr + 1
						If UpGrade\Nr >= 6 And Upgrade\Nr < 12 Then Spieler\Image = SpielerHut(2)
						If UpGrade\Nr >= 12 And Upgrade\Nr < 20 Then Spieler\Image = SpielerHut(3)
						If UpGrade\Nr = 20 Then Spieler\Image = SpielerHut(4)
						UpGrade\Kosten = Upgrade\Kosten + (0.5*Upgrade\Nr)
					EndIf
				EndIf
			EndIf
		Next
	EndIf
	;/
	
	
	;Abfrage fr das Schuss Upgrade:
	If keyh And ImagesOverlap(SchussUp, 150, 400, Maus, MouseX(), MouseY()) Then
		For UpGrade.TUpgrade = Each TUpgrade
			If UpGrade\ID = 2 Then
				If Upgrade\Nr < 4 Then
					If Spieler\Geld >= UpGrade\Kosten Then
						Spieler\SchussLevel = Spieler\SchussLevel + Upgrade\Menge
						Spieler\Geld = Spieler\Geld - Upgrade\Kosten
						UpGrade\Nr = Upgrade\Nr + 1
						Spieler\SchussTimer = Spieler\SchussTimer - (Spieler\SchussLevel*13)
						Upgrade\Kosten = Upgrade\Kosten + (5*Upgrade\Nr)
						If UpGrade\Nr = 1 Then Spieler\Image2 = SpielerK(2)
						If UpGrade\Nr = 2 Then Spieler\Image2 = SpielerK(3)
						If UpGrade\Nr = 3 Then Spieler\Image2 = SpielerK(4)
						If Upgrade\Nr = 4 Then Spieler\Image2 = SpielerK(5)
						If Spieler\SchussLevel = 3 Then
							Spieler\BigTime = 5000
						EndIf
					EndIf
				EndIf
			EndIf
		Next
	EndIf
	;/
	
	;Abfrage fr das EnergieUpGrade:
	If keyh And ImagesOverlap(EnergieUp, 650, 100, Maus, MouseX(), MouseY()) Then
		For UpGrade.TUpgrade = Each TUpgrade
			If UpGrade\ID = 3 Then
				;If Upgrade\Nr < 10 Then
					If Spieler\Geld >= UpGrade\Kosten Then
						Spieler\Energie = Spieler\Energie + UpGrade\Menge#
						Spieler\Geld = Spieler\Geld - Upgrade\Kosten
						UpGrade\Nr = UpGrade\Nr + 1
						UpGrade\Kosten = Upgrade\Kosten + (3*Upgrade\Nr)
					EndIf
				;EndIf
			EndIf
		Next
	EndIf
	;/
	
End Function
;/


;Das Level zeichnen
Function DrawLevel()
	
	Verschiebung# = Verschiebung# + 1 ;Das Level bewegen
	If Verschiebung# >=  (GraphicsWidth()) Then 
		Verschiebung# = 0
		SchiebNr = SchiebNr + 1
	EndIf
	
	If SchiebNr > 3 Then SchiebNr = 0 
	
	SetLevel() 
	
	DrawBlock Himmel, GraphicsWidth()/2-Verschiebung#, GraphicsHeight()/2
	DrawBlock Himmel, (GraphicsWidth()+(GraphicsWidth()/2))-Verschiebung#, GraphicsHeight()/2
	
	
	;Text 100, 100, SchiebNr
	;Text 100, 200, Verschiebung#
	
	DrawImage Bild1, GraphicsWidth()/2-(Verschiebung#), GraphicsHeight()/2
	DrawImage Bild2, (GraphicsWidth()+(GraphicsWidth()/2))-(Verschiebung#), GraphicsHeight()/2
	
End Function
;/


;Steuerung fr den Spieler:
Function SpielerSteuerung()
	
	Local AltY#
	AltY# = Spieler\YPos#
	
	If KeyDown(200) Then Spieler\YPos# = Spieler\YPos# - Spieler\Speed# ;Bewegung nach oben
	If KeyDown(208) Then Spieler\YPos# = Spieler\YPos# + Spieler\Speed# ;Bewegung nach unten
	
	
	If Spieler\YPos# < 34 Then Spieler\YPos# = AltY#
	If Spieler\YPos# > 727 Then Spieler\YPos = AltY#
	
	;Schsse erstellen:
	If KeyDown(57) Then
		If ((Spieler\SchussStart + Spieler\SchussTimer) < MilliSecs()) Then
			SetShootPlayer(Spieler\SchussLevel)
			Spieler\SchussStart = MilliSecs()
		EndIf
	EndIf
	;/
	
End Function
;/


;LevelUp:
Function SpielerErfahrung()
	
	If Spieler\Erfahrung > (100*(Spieler\Level/1.5)) Then
		Spieler\Level = Spieler\Level + 1
		Spieler\Speed = Spieler\Speed + (Spieler\Level / 10)
		Spieler\Energie = Spieler\Energie + (Spieler\Level * 5)
		Spieler\VolleEnergie# = Spieler\VolleEnergie# + (Spieler\Level * 5)
		Spieler\Erfahrung = 0
		PLevelUp = 1
		PLevelUpStart = MilliSecs()
	EndIf
	
End Function
;/


;Alle Kollisionen:
Function Kollision()
	Local Energie# = 0
	
	;Kollision Gegner<->SpielerSchuss:
	For Gegner.TGegner = Each TGegner
		For Schuss.TSchussSpieler = Each TSchussSpieler
			If SChuss\Dead = 0 Then
					If Gegner\Dead = 0 Then
						;If RectsOverlap((Gegner\XPos# - (ImageWidth(Gegner\Image\Image)/2.5)), (Gegner\YPos# - (ImageHeight(Gegner\Image\Image)/2.5)), (ImageWidth(Gegner\Image\Image)/1.3), (ImageHeight(Gegner\Image\Image)/1.3), (Schuss\XPos#-(ImageWidth(Schuss\Image\Image)/4)), (Schuss\YPos#-(ImageHeight(Schuss\Image\Image)/4)), (ImageWidth(Schuss\Image\Image)/2), (ImageHeight(Schuss\Image\Image)/2)) Then
						If ImagesOverlap(Gegner\Image\Image, Gegner\XPos#, Gegner\YPos#, Schuss\Image\Image, Schuss\XPos#, Schuss\YPos#) Then
						Energie# = Gegner\Energie#
							Gegner\Energie# =  Gegner\Energie# - Schuss\Kraft#
							Schuss\Kraft# = (Schuss\Kraft# - Energie#)
							
							If Gegner\Energie# <= 0 Then
								CreateGeld(Gegner.TGegner)
								SetPartikelExplo(Gegner.TGegner)
								Gegner\Dead = 1
								Spieler\Erfahrung = Spieler\Erfahrung + ((Gegner\Erfahrung * Gegner\Level) / Spieler\Level)
							EndIf
								
							If Schuss\Kraft# <= 0 Then
								Schuss\Dead = 1
							EndIf
							
					EndIf
				EndIf
			EndIf
		Next
	Next
	;/
	
	;Kollision Spieler<->GegnerSchuss:
	For SchussGegner.TSchussGegner = Each TSchussGegner
		If SchussGegner\Dead  = 0 Then
			;If RectsOverlap(Spieler\XPos#-28, Spieler\YPos#-28, 56, 79, SchussGegner\XPos#-(ImageWidth(SchussGegner\Image\Image)/4), SchussGegner\YPos#-(ImageHeight(SchussGegner\Image\Image)/4), ImageWidth(SchussGegner\Image\Image)/2, ImageHeight(SchussGegner\Image\Image)/2) Then
			If (ImagesOverlap(Spieler\Image, Spieler\XPos#, Spieler\YPos#, SChussGegner\Image\Image, SchussGegner\XPos#, SChussGegner\YPos#) Or ImagesOverlap(Spieler\Image2, Spieler\XPos#, Spieler\YPos#, SChussGegner\Image\Image, SchussGegner\XPos#, SChussGegner\YPos#)) Then
				Energie# = Spieler\Energie#
				Spieler\Energie# = Spieler\Energie# - SchussGegner\Kraft#
				SchussGegner\Kraft# = (SchussGegner\Kraft# - Energie#)
				
				If SchussGegner\Kraft <= 0 Then
					SchussGegner\Dead = 1
				EndIf
				
			EndIf
		EndIf
	Next
	;/
	
	;Kollision Spieler<->Geld
	For Geld.TGeld = Each TGeld
		If Geld\Dead = 0 Then
			;If RectsOverlap(Geld\XPos#-(ImageWidth(Geld\Image\Image)/4), Geld\YPos#-(ImageHeight(Geld\Image\Image)/4), ImageWidth(Geld\Image\Image)/2, ImageHeight(Geld\Image\Image)/2, Spieler\XPos#-28, Spieler\YPos#-28, 56, 79) Then
				If (ImagesOverlap(Spieler\Image, Spieler\XPos#, Spieler\YPos#, Geld\Image\Image, Geld\XPos#, Geld\YPos#) Or ImagesOverlap(Spieler\Image2, Spieler\XPos#, Spieler\YPos#, Geld\Image\Image, Geld\XPos#, Geld\YPos#)) Then	
				Geld\Dead = 1
				Spieler\Geld = Spieler\Geld + Geld\Menge
			EndIf
		EndIf
	Next
	;/
	
End Function
;/
;~IDEal Editor Parameters:
;~F#91#99#A0#A8#AE#BB#C3#C9#221#267#282#29C#2AD
;~C#Blitz3D