
Function CreateWayPoints()
	For i=50 To -20 Step -20
		WayPoint[j] = CreateSphere(10)
		ScaleEntity WayPoint[j], 6,.01,6
		PositionEntity WayPoint[j],-40,0,i
		EntityBlend WayPoint[j],3
		EntityColor WayPoint[j],0,0,200
		j=j+1
	Next
	
	For i=30 To -20 Step -20
		WayPoint[j] = CreateSphere(10)
		ScaleEntity WayPoint[j], 6,.01,6
		PositionEntity WayPoint[j],40,0,i
		EntityBlend WayPoint[j],3
		EntityColor WayPoint[j],0,0,200
		j=j+1
	Next
	
	temp = WayPoint[2]
	WayPoint[2] = WayPoint[4]
	WayPoint[4]=temp
	temp = WayPoint[3]
	WayPoint[3] = WayPoint[5]
	WayPoint[5]=temp
	
	
End Function

Function CreateMap()
	Ebene = CreatePlane()
	EntityTexture Ebene, G_Tex 
	ScaleTexture G_Tex, 2,2
	EntityPickMode Ebene,2
	
	Wall(-70,-60,70,-60)
	Wall(-70,70,70,70)
	Wall(-70,-60,-70,70)
	Wall(70,-60,70,70)
	
	
	For i=60 To -30 Step -40
		Wall(-50,i,50-20,i)
	Next
	
	For i=40 To -30 Step -40
		Wall(-50+20,i,50,i)
	Next
	
	Wall(30,60,50,60)
	Wall(-50,-20,-50,59)
	Wall(50,-20,50,59)
	
	
	c = CreateCube()
	ScaleEntity c,3,.1,3
	PositionEntity c,40,0,50
	EntityTexture c,S_Tex
End Function

Function CreateHQ()
	MainBuilding = CreateCube()
	PositionEntity MainBuilding,0,0,-50
	ScaleEntity MainBuilding, 4,1,4
	EntityTexture MainBuilding,W_Tex2
	EntityColor MainBuilding,150,150,150
	s = CreateCube()
	PositionEntity s,0,2,-50
	ScaleEntity s, 2,1,2
	EntityTexture s,W_Tex2
	RotateEntity s,0,45,0
	s = CreateCube()
	PositionEntity s,3,0,-47
	ScaleEntity s, 1,3,1
	EntityTexture s,W_Tex2
	s = CreateCube()
	PositionEntity s,-3,0,-47
	ScaleEntity s, 1,3,1
	EntityTexture s,W_Tex2
	s = CreateCube()
	PositionEntity s,3,0,-53
	ScaleEntity s, 1,3,1
	EntityTexture s,W_Tex2
	s = CreateCube()
	PositionEntity s,-3,0,-53
	ScaleEntity s, 1,3,1
	EntityTexture s,W_Tex2
End Function


Function CreateCameras()
	cam = CreateCamera()
	PositionEntity cam,0,15,0
	TurnEntity cam,70,0,0
	CameraViewport cam, 0, 0, GWidth, GHeight-170
	MoveMouse 400,300
	
	
	ObjectCam = CreateCamera()
	PositionEntity ObjectCam,0,15,0
	TurnEntity ObjectCam,45,0,0
	CameraViewport ObjectCam, 251, GHeight -159, 148, 148
	CameraClsMode ObjectCam, 1, 1
End Function

Function CreateLightning()
	light=CreateLight(3)
	PositionEntity light,0,15,0
	PointEntity light,CreatePivot()
	
End Function


Function CreateBuilder()
	Builder = CreateSphere()
	
	C=CreateCone(8,0,Builder)
	PositionMesh c,0,2,0
	EntityTexture c,W_Tex
	EntityTexture Builder, S_Tex
	PaintMesh c,CreateBrush(250,0,0)
	PositionEntity Builder,0,0,-40
	PositionEntity Destination,0,0,-40
	
	;EntityPickMode ,1
	EntityPickMode c,1
	AddMesh c,Builder
	FreeEntity c
	EntityPickMode Builder,2
End Function


Function CreateBug()
	CurrentTower = CreateCube()
	TurnEntity CurrentTower,0,0,0
	EntityTexture CurrentTower, Bug_Tex
	;RotateEntity CurrentTower,90,0,0
	EntityColor CurrentTower,255,255,255
	ScaleEntity CurrentTower, 1,.01,1
	EntityBox CurrentTower,-.5,-.5,-.5,1,1,1
	
	Tower.TTower = New TTower
	Tower\mesh = CurrentTower
	Tower\typ = 3
	Tower\y = .1
	
	Tower\radius = 10
	Tower\cost=20
	Tower\damage = 9
	Tower\speed = 2000
End Function

Function CreateToDo()
	CurrentTower = CreateCube()
	TurnEntity CurrentTower,0,0,0
	EntityTexture CurrentTower, ToDo_Tex
	EntityColor CurrentTower,255,255,255
	ScaleEntity CurrentTower, 1,.01,1
	EntityBox CurrentTower,-.5,-.5,-.5,1,1,1
	
	Tower.TTower = New TTower
	Tower\mesh = CurrentTower
	Tower\typ = 4
	Tower\y = .1
	
	Tower\radius = 30
	Tower\cost=30
	Tower\damage = 9
	Tower\speed = 600
End Function


Function CreateEndlosSchleife()
	CurrentTower = CreateCube()
	TurnEntity CurrentTower,0,0,0
	EntityTexture CurrentTower, Schleife_Tex
	RotateEntity CurrentTower,90,0,0
	EntityColor CurrentTower,255,255,255
	ScaleEntity CurrentTower, 1,.01,1
	EntityBox CurrentTower,-.5,-.5,-.5,1,1,1
	
	Tower.TTower = New TTower
	Tower\mesh = CurrentTower
	Tower\typ = 5
	Tower\y = 1
	
	Tower\radius = 15
	Tower\cost=50
	Tower\damage = 10
	Tower\speed = 1400
End Function


Function CreateIfSchleife()
	CurrentTower = CreateCube()
	TurnEntity CurrentTower,0,0,0
	EntityTexture CurrentTower, IF_Tex
	EntityColor CurrentTower,255,255,255
	ScaleEntity CurrentTower, 1,.01,1
	EntityBox CurrentTower,-.5,-.5,-.5,1,1,1
	
	Tower.TTower = New TTower
	Tower\mesh = CurrentTower
	Tower\typ = 2
	Tower\y = .1
	
	Tower\radius = 20
	Tower\cost=16
	Tower\damage = 4
	Tower\speed = 1400
End Function

Function CreateGotoSprung()
	CurrentTower = CreateCube()
	TurnEntity CurrentTower,0,45,0
	EntityTexture CurrentTower, GOTO_Tex
	
	ScaleEntity CurrentTower, .5,.5,.5
	EntityBox CurrentTower,-.5,-.5,-.5,1,1,1
	
	Tower.TTower = New TTower
	Tower\mesh = CurrentTower
	Tower\typ = 1
	Tower\y = 1
	Tower\radius = 30
	
	Tower\cost=9
	
	Tower\damage = 1
	Tower\speed = 800
End Function



Function CreateMarkers()
	Selection_circle = CreateSphere(5)
	ScaleEntity Selection_circle, 2,.01,2
	EntityAlpha Selection_circle,0
	EntityBlend Selection_circle,3
	EntityColor Selection_circle,200,0,0
	
	MouseOver_Sqare = CreateCube()
	ScaleEntity MouseOver_Sqare, 1,.1,1
	EntityAlpha MouseOver_Sqare,0
	EntityBlend MouseOver_Sqare,3
	EntityColor MouseOver_Sqare,200,0,0
	
	Building_Sqare = CreateCube()
	ScaleEntity Building_Sqare, 1,.1,1
	EntityAlpha Building_Sqare,0
	EntityBlend Building_Sqare,3
	EntityColor Building_Sqare,200,0,0
End Function


Function Wall(x,y,x2,y2)
	MMap(70+x,70+y)=1
	MMap(70+x,70+y+1)=1
	MMap(70+x+1,70+y)=1
	MMap(70+x+1,70+y+1)=1
	c=CreateCube()
	ScaleMesh c,1,2,1
	EntityTexture c,W_Tex
	PositionMesh c, x,1,y
	
	w.TWall = New TWall
	w\x = x
	w\y = y
	
	For i=x To x2 Step 2
		For j=y To y2 Step 2
			MMap(70+i,70+j)=1
			MMap(70+i,70+j+1)=1
			MMap(70+i+1,70+j)=1
			MMap(70+i+1,70+j+1)=1
			
			c2=CreateCube()
			ScaleMesh c2,1,2,1
			PositionMesh c2,i,1,j
			AddMesh c2,c
			FreeEntity c2
			w.TWall = New TWall
			w\x = i
			w\y = j
		Next
	Next
End Function

;~IDEal Editor Parameters:
;~C#Blitz3D