Graphics 640,480,32,2

Global GWidth% = 1024
Global GHeight% = 768

Print "Aktuelle Auflsung: 1024x768"
i$=Input("Auflsung ndern?(j/n)")

If j="j" Then 
	GWidth = Input("X: ")
	GHeight = Input("Y: ")
EndIf


Print "-------------------------"
Print "Steuerung:"
Print "Linke Maustaste - Objekt auswhlen"
Print "Rechte Maustaste - Programmierer zu Ort schicken"
Print "Linke Maustaste - Objekt bauen
Print "Shift - Zum Wiederholten Bauen gedrckt halten"
Print "-------------------------"



Print "Der blaue Punkt auf der Minimap ist dein Programmierer!"
Print "Ziel des Spiels ist die Eliminierung der Bugs mithilfe der Tower!"

Print "Viel Spa!"


Print "Beliebige Taste drcken..."
WaitKey()



Include "includes\header.bb"

Graphics3D  GWidth, GHeight,32,1
HidePointer()
SetBuffer BackBuffer()


Global mouse = LoadImage("data/mouse.bmp")
MaskImage mouse, 255,255,255

Global L = LoadImage("data/l.jpg")

Global font1 = LoadFont("Arial",15)
Global font2 = LoadFont("Arial",15,0,1,0)
Global font3 = LoadFont("Arial",16,0,1,1)
Global font4 = LoadFont("Arial",30,1,1,0)
Global font5 = LoadFont("Arial",40,1,1,0)



SetFont font1
Global G_Tex = LoadTexture("data/gras.jpg")
Global W_Tex = LoadTexture("data/Wall.jpg")
Global W_Tex2 = LoadTexture("data/hq.jpg",256)
Global S_Tex = LoadTexture("data/cp.jpg")
Global GOTO_Tex = LoadTexture("Data/goto.jpg")
Global IF_Tex = LoadTexture("Data/if.bmp",1+2)
Global Schleife_Tex = LoadTexture("Data/schleife.bmp",1+2)

Global Bug_Tex = LoadTexture("Data/bug.bmp",1+2)
Global Func_Tex = LoadTexture("Data/func.jpg")
Global ToDo_Tex = LoadTexture("Data/todo.jpg")

Global Exex_Tex = LoadTexture("Data/exex.jpg")
Global MAV_Tex = LoadTexture("Data/mav.jpg")

ScaleTexture S_Tex,.2,.2
ScaleTexture W_Tex2,.2,.2

Global MainBuilding
Global WayPoint[9]
Global MiniMap_x
Global MiniMap_Y
Global PickedObject
Global Selected_Object
Global Ebene
Global Destination = CreatePivot()
Global TowerBuilding
Global CurrentTower
Global BuildPossible
Global Builder
Global light
Global Selection_circle
Global Building_Sqare
Global MouseOver_Sqare
Global cam
Global ObjectCam
Global BuilderMoving
Global CurrentTowerInfo%

Include "includes\CreateThings.bb"
Include "includes\DrawThings.bb"
Include "includes\Pathfinding.bb"

CreateCameras()
CreateMap()
CreateHQ()
CreateLightning()
CreateBuilder()
CreateMarkers()


Const DEBUG_PATHFINDING = 0


;Maustasten
Global MH,MD,MH2
;Auswahlrechteck
Global S_X,S_Y,QX,QY,QX2,QY2

;Timung
Global FSTart,FTime


Global Level%=1
Global new_level%
Global LevelTxtX=-300,LevelTxtY=300
Global Leben%=30


PathCheck(40,50,0,-50)
RotateTexture Func_Tex,-90

Global ready
Global ms

Global Enemy_Count=10
Global CurrentEnemy_Count=Enemy_Count
Global Enemy_StartTime
Global Money%=40
Global pathupdated

SeedRnd MilliSecs()
Repeat
	FSTart = MilliSecs() 
	Cls
	
	If Enemy_Count > 1 And MilliSecs() - Enemy_StartTime > 2000 Then
		Enemy_StartTime = MilliSecs()
		Local e.TEnemy = New TEnemy
		e\mesh = CreateCube()
		
		Select Rand(0,9)
			Case 1:
				EntityTexture e\mesh,Func_Tex
			Case 2:
				EntityTexture e\mesh,Exex_Tex
			Case 3:
				EntityTexture e\mesh,Exex_Tex
				
			Case 4:
				EntityTexture e\mesh,MAV_Tex
			Case 5:
				EntityTexture e\mesh,MAV_Tex
			Default: 
				EntityTexture e\mesh,Func_Tex
				
		End Select
		
		ScaleEntity e\mesh, .75,.01,.75
		e\x = 40
		e\y = 50
		
		Select Level
			Case 1:
				e\speed = 2.5
				e\health = 10
			Case 2:
				e\speed = 3
				e\health = 25
			Case 3:
				e\speed = 5
				e\health = 50
			Case 4:
				e\speed = 6
				e\health = 70
			Case 5:
				e\speed = 7
				e\health = 150
			Case 6:
				e\speed = 8
				e\health = 200
			Case 7:
				e\speed = 9
				e\health = 300
				
			Case 8:
				e\speed = 9
				e\health = 400
				
			Case 9:
				e\speed = 9
				e\health = 500
				
			Case 10:
				e\speed = 9
				e\health = 600
			Case 11:
				e\speed = 8
				e\health = 1000
		End Select
		
		PositionEntity e\mesh,e\x,2,e\y
		
		e\WP = First TPathKnots
		PointEntity e\mesh,e\WP\piv
		
		Enemy_Count=Enemy_Count-1
	EndIf
	
	If CurrentEnemy_Count = 0 Then Level=Level+1
	
	If Level = 12 Then RuntimeError("Sie haben gewonnen!")
	
	MH = MouseHit(1)
	MD = MouseDown(1)
	MH2 = MouseHit(2)
	If KeyHit(3)
		DeletePath()
		
		PathCheck(40,50,0,-50)
	EndIf
	
	Scrolling()
	KI()
	
	HUD()
	
	UpdateWorld()
	RenderWorld()
	MouseSelection()
	DrawInfo(CurrentTowerInfo)
	
	Color 250,200,0
	
	
	
	If new_level <> Level Then
		Select new_level
			Case 0:
				Enemy_Count = 10
			Case 1:
				Enemy_Count = 15
			Case 2:
				Enemy_Count = 10
			Case 3:
				Enemy_Count = 10
			Case 4:
				Enemy_Count = 10
			Case 5:
				Enemy_Count = 10
			Case 6:
				Enemy_Count = 10
			Case 7:
				Enemy_Count = 10
				
			Case 8:
				Enemy_Count = 10
				
			Case 9:
				Enemy_Count = 10
				
			Case 10:
				Enemy_Count = 10
			Case 11:
				Enemy_Count = 1
		End Select
		CurrentEnemy_Count=Enemy_Count
		tmpms=MilliSecs()
		
		If LevelTxtX < 10 Then 
			LevelTxtX=LevelTxtX +FSpeed(300)
		Else
			new_level = Level
			
		EndIf
	Else
		If MilliSecs()-tmpms > 5000 And LevelTxtX > -500 Then
			LevelTxtX=LevelTxtX-FSpeed(200)
		EndIf
	EndIf
	
	If KeyHit(2) Then Level=Level+1
	
	SetFont font4
	
	
	If Level>1 Then Text LevelTxtX,LevelTxtY-50,NLevel[Level-2] +" erfolgreich programmiert!" 
	
	SetFont font5
	Text LevelTxtX,LevelTxtY,"Neues Level: " + Level
	Text LevelTxtX+10,LevelTxtY+50,NLevel[Level-1]+"!"
	
	Text 0,GraphicsHeight()-210,"Geld: "+Money
	
	Color 200,0,0
	Text GraphicsWidth()/2,GraphicsHeight()-200,"Leben  brig: "+Leben,1,1
	
	DrawImage mouse,MouseX(),MouseY()
	
	Flip 0
	FTime = MilliSecs() - FSTart 
Until KeyHit(1)

Function FSpeed#(speed#)
	Return (speed# * (FTime/500.0))
End Function

Global Tower.TTower

Function MouseSelection()
	If MD And MouseY() < GHeight -170 Then
		If S_X = 0 And S_Y = 0 Then
			S_X = MouseX()
			S_Y = MouseY()
		EndIf
		Color 255,1,1
		
		If MouseX() > S_X Then
			QX = S_X
			QX2 = -S_X+MouseX()
		Else
			QX = MouseX()
			QX2 = S_X-MouseX()
			
		EndIf
		
		If MouseY() > S_Y Then
			QY = S_Y
			QY2 =  -S_Y+MouseY()
		Else
			QY = MouseY()
			QY2 = S_Y - MouseY()
		EndIf
		Rect QX,QY,QX2,QY2,0
	Else
		If S_X <> 0 And S_Y <> 0 Then
			S_X = 0
			S_Y = 0
		EndIf
	EndIf
	
	ObjectSelection()
	
End Function


Global ObjectAlpha#

Function MouseOverObject(obj%)
	If obj>0 Then
		
		Local alpha#
		
		If PickedObject <> obj And PickedObject <> 0 Then
			
			EntityAlpha MouseOver_Sqare,0
			
			EntityAlpha PickedObject,ObjectAlpha
			EntityFX PickedObject,0
			PickedObject=0
		EndIf
		
		If obj <> Ebene Then
			ObjectAlpha#=VertexAlpha (GetSurface(obj,1), 0)
			
			PickedObject = obj
			
			If obj<> Builder Then 
				PositionEntity MouseOver_Sqare,EntityX(obj),0.1,EntityZ(obj)
				EntityAlpha MouseOver_Sqare,.5
			EndIf
			
			EntityAlpha obj,.6
			EntityFX obj,1
		EndIf
	Else
		If PickedObject <> obj Then
			
			EntityAlpha MouseOver_Sqare,0
			EntityAlpha PickedObject,ObjectAlpha
			EntityFX PickedObject,0
			PickedObject=0
		EndIf
	EndIf
End Function

Function SelectionCircle()
	If Selected_Object <> 0 Then
		PositionEntity Selection_circle,EntityX(Selected_Object),0,EntityZ(Selected_Object)
		EntityAlpha Selection_circle,1
		TurnEntity Selection_circle,0,1,0
	Else
		EntityAlpha Selection_circle,0
	EndIf
End Function

Function ControlBuilder(obj%)
	
	Local lTower.TTower
	
	Local Built=0
	Local To_Build=0
	
	For lTower = Each TTower
		If lTower\placed = 1 Then
			If lTower\towerbuilt = 0 Then To_Build=1
			
			If EntityDistance(lTower\mesh,Builder )< 2 Then 
				If lTower\towerbuilt = 0 Then
					lTower\towerbuilt=1
					EntityAlpha lTower\mesh,1
				EndIf
			Else
				If lTower\towerbuilt=0 Then PositionEntity Destination,EntityX(lTower\mesh),0,EntityZ(lTower\mesh)
			EndIf
		EndIf
	Next		
	
	If Selected_Object <> 0 Then
		If Selected_Object=Builder Then
			If MH2 Then
				If obj = Ebene Then
					PositionEntity Destination,PickedX(),0,PickedZ()
					TowerBuilding = 0
					;FreeEntity CurrentTower
					For lTower = Each TTower
						If lTower\towerbuilt = 0 Then 
							FreeEntity lTower\mesh
							
							MMap(70+lTower\x,70+lTower\y)=0
							MMap(70+lTower\x,70+lTower\y+1)=0
							MMap(70+lTower\x+1,70+lTower\y)=0
							MMap(70+lTower\x+1,70+lTower\y+1)=0
							Delete lTower
							
						EndIf
					Next
				EndIf
			EndIf
		EndIf
	EndIf
End Function

Global timer,timer2


Function ObjectSelection()
	timer = MilliSecs()
	MiniCam()
	SelectionCircle()
	
	If MouseY() < GHeight -170 Then
		
		Local obj = CameraPick(cam, MouseX(),MouseY())
		
		ControlBuilder(obj)
		
		If TowerBuilding = 0 Then
			EntityAlpha Building_Sqare,0
			MouseOverObject(obj)
			
			If MH And obj>0 And obj <> Ebene Then Selected_Object = obj 
			If MH And obj=0 And Selected_Object<>0 Then Selected_Object = 0 
			If MH And obj=Ebene And Selected_Object<>0 Then Selected_Object = 0 
			
			
			
			If Selected_Object <> 0 Then
				
			EndIf
			
		Else
			
			Local MMap_x = Int(PickedX())
			Local MMap_y = Int(PickedZ())
			
			PositionEntity CurrentTower,MMap_x,Tower\y,MMap_y
			PositionEntity Building_Sqare,MMap_x,0.01,MMap_y
			EntityAlpha Building_Sqare,1
			
			
			If (MMap(70+MMap_x,70+MMap_y)=0) And (MMap(70+MMap_x+1,70+MMap_y)=0) And (MMap(70+MMap_x,70+MMap_y+1)=0) And (MMap(70+MMap_x+1,70+MMap_y+1)=0) Then 
				EntityColor Building_Sqare,0,200,0
				BuildPossible = 1
			Else
				BuildPossible = 0
				EntityColor Building_Sqare,200,0,0
			EndIf
			
			
			If MH Then
				If EnemyNear() <> 1 Then 
					If BuildPossible = 1
						Money=Money-Tower\cost
				;	PositionEntity Building_Sqare
						Tower\placed = 1
						
						
						
						
						If BuilderMoving = 0 Then PositionEntity Destination, MMap_x,0,MMap_y : BuilderMoving = 1
						
						MMap(70+MMap_x,70+MMap_y)=1
						MMap(70+MMap_x,70+MMap_y+1)=1
						MMap(70+MMap_x+1,70+MMap_y)=1
						MMap(70+MMap_x+1,70+MMap_y+1)=1
						
						UpdatePathfinding(MMap_x,MMap_y)
						
						EntityPickMode CurrentTower,3
						TowerBuilding=0
						
						Tower\x = MMap_x
						;Tower\y = MMap_y
						Tower\z = MMap_y
						
						EntityAlpha Tower\mesh,.3
						
						
						If KeyDown(42) Then
							If Money>=Tower\cost Then 
								Select Tower\typ
									Case 1:
										TowerBuilding=1
										CreateGotoSprung()
										
									Case 2: 
										TowerBuilding=1
										CreateIfSchleife()
								End Select
							EndIf
						EndIf
						
						EntityAlpha Building_Sqare,0
					EndIf
				EndIf
			EndIf
		EndIf
		
	EndIf
	timer2 = MilliSecs()-timer
	
End Function



Function KI()
	Local e.TEnemy
	For e.TEnemy = Each TEnemy
		
		If e\WP = Null Then
			Local tempa=KnotOnPos(e\WP_x,e\wp_Y)
			If tempa <> 0 Then 
				e\WP = Object.TPathKnots(tempa)
			Else
				e\WP = First TPathKnots
			EndIf
		EndIf
		
		
		If EntityDistance(e\mesh,e\WP\piv) < 2 Then
			If e\WP <> Last TPathKnots Then
				e\WP = After e\WP
				e\WP_x = e\WP\X
				e\wp_Y = e\WP\Y
			Else
				FreeEntity e\mesh
				Delete e
				Leben=Leben-1
				CurrentEnemy_Count=CurrentEnemy_Count-1
				If Leben = 0 Then RuntimeError("Sie haben verloren!")
				
			EndIf
		EndIf
		
		If e <> Null Then
			
			PointEntity e\mesh,e\WP\piv
			MoveEntity e\mesh,0,0,FSpeed(e\speed)
			e\x = EntityX(e\mesh)
			e\y = EntityZ(e\mesh)
			
			
			If e\health <= 0 Then 
				FreeEntity e\mesh 
				Delete e 
				CurrentEnemy_Count=CurrentEnemy_Count-1
				Money=Money+(Level*2)
			EndIf
		EndIf
	Next
	
	Local t.TTower
	For t.TTower = Each TTower
		If TowerBuilding=0 And t\placed=0 Then
			Delete t
		EndIf
		If t<>Null
			If t\towerbuilt=1 Then
				If MilliSecs()-t\timer > t\speed Then
					For e.TEnemy = Each TEnemy
						If EntityDistance(e\mesh,t\mesh) < t\radius Then
							t\timer = MilliSecs()
							
							s.TSchuss = New TSchuss
							s\mesh = CopyEntity(t\mesh)
							EntityAlpha s\mesh,.3
							EntityPickMode s\mesh,0
							s\destination = e
							s\dmg = t\damage
							
							Exit
						EndIf
					Next
				EndIf
			EndIf
		EndIf
	Next
	
	For s.TSchuss = Each TSchuss
		If s\destination = Null Then FreeEntity s\mesh : Delete s
		If s<>Null
			PointEntity s\mesh,s\destination\mesh
			MoveEntity s\mesh, 0,0,FSpeed(20)
			
			If EntityDistance(s\mesh,s\destination\mesh) < 3 Then
				s\destination\health=s\destination\health-s\dmg
				FreeEntity s\mesh
				Delete s
			EndIf
		EndIf
	Next
	
	If EntityDistance(Builder,Destination) > 1 Then
		PointEntity Builder,Destination
		MoveEntity Builder,0,0,FSpeed(10)
		PositionEntity Selection_circle,EntityX(Builder),0,EntityZ(Builder)
	EndIf
	
End Function

Function HUD()
	For x=0 To GWidth Step 10
		DrawImage L,x,GHeight-170
	Next
	
	MiniMap()
	
	Color 100,100,150
	Rect 248, GHeight -162, 154, 154,1
	Color 140,140,160
	Rect 220,GHeight -166,5,166
	Color 140,140,160
	Rect 230,GHeight -166,5,166
	Color 160,160,190
	Rect 225,GHeight -166,5,166
	
	Color 180,180,210
	Rect 420,GHeight -160,130,20,1
	Color 90,130,90
	Rect 420,GHeight -160,130,20,0
	Color 0,0,0
	
	
	Color 180,180,210
	Rect 420,GHeight -136,130,110,1
	Color 90,130,90
	Rect 420,GHeight -136,130,110,0
	Color 0,0,0
	SetFont font1
	Text 425,GHeight -130, "Leben:"
	Text 425,GHeight -110, "Rstung:"
	Text 425,GHeight -90, "Angriff:"
	Text 425,GHeight -70, "Reichw:"
	Text 425,GHeight -50, "Geschw:"
	
	If Selected_Object = Builder Then
		SetFont font1
		Color 0,0,0
		Text 425,GHeight -158, "Der Programmierer"
		
		SetFont font2
		Color 200,0,0
		Text 425+53,GHeight -130, "unbegrenzt"
		Text 425+53,GHeight -110, "unbegrenzt"
		Text 425+53,GHeight -90, "0"
		Text 425+53,GHeight -70, "0"
		Text 425+53,GHeight -50, "10"
		
		
		Color 180,180,210
		Rect 580,GHeight -160,130,20,1
		Color 90,130,90
		Rect 580,GHeight -160,130,20,0
		
		SetFont font1
		Color 0,0,0
		Text 585,GHeight -158, "Compile:"
		
		
		Color 180,180,210
		Rect 580,GHeight -136,130,120,1
		Color 90,130,90
		Rect 580,GHeight -136,130,120,0
		
		If RectsOverlap(MouseX(),MouseY(),3,3,580,GHeight -130,130,20) Then 
			Color 90,130,90
			Rect 580,GHeight -136,130,20,1
			If MH Then 
				If Money>=9 Then
					
					If TowerBuilding=1 And CurrentTower<>0 Then
						FreeEntity CurrentTower
					EndIf
					TowerBuilding=1
					CreateGotoSprung()
				EndIf
			EndIf
			
			CurrentTowerInfo = 1
		ElseIf RectsOverlap(MouseX(),MouseY(),3,3,580,GHeight -110,130,20) Then 
			
			
			
			Color 90,130,90
			Rect 580,GHeight -116,130,20,1
			If MH Then 
				If Money>=16 Then
					
					If TowerBuilding=1 And CurrentTower<>0 Then
						FreeEntity CurrentTower
					EndIf
					
					TowerBuilding=1
					CreateIfSchleife()
				EndIf
			EndIf
			
			
			CurrentTowerInfo = 2
		ElseIf RectsOverlap(MouseX(),MouseY(),3,3,580,GHeight -90,130,20) Then 
			Color 90,130,90
			Rect 580,GHeight -96,130,20,1
			If MH Then 
				If Money>=20 Then
					
					If TowerBuilding=1 And CurrentTower<>0 Then
						FreeEntity CurrentTower
					EndIf
					
					TowerBuilding=1
					CreateBug()
				EndIf
			EndIf
			
			
			CurrentTowerInfo = 3
		ElseIf RectsOverlap(MouseX(),MouseY(),3,3,580,GHeight -70,130,20) Then 
			
			
			Color 90,130,90
			Rect 580,GHeight -76,130,20,1
			If MH Then 
				If Money>=30 Then
					
					If TowerBuilding=1 And CurrentTower<>0 Then
						FreeEntity CurrentTower
					EndIf
					
					TowerBuilding=1
					CreateToDo()
				EndIf
			EndIf
			
			
			CurrentTowerInfo = 4
		ElseIf RectsOverlap(MouseX(),MouseY(),3,3,580,GHeight -50,130,20) Then 
			
			
			Color 90,130,90
			Rect 580,GHeight -56,130,20,1
			If MH Then 
				If Money>=50 Then
					
					If TowerBuilding=1 And CurrentTower<>0 Then
						FreeEntity CurrentTower
					EndIf
					
					TowerBuilding=1
					CreateEndlosSchleife()
				EndIf
			EndIf
			
			CurrentTowerInfo = 4
		Else
			CurrentTowerInfo = 0
		EndIf
		
		
		Color 0,0,0
		SetFont font1
		Text 580+65,GHeight -132, "GoTo Sprung(9)",1,0
		Text 580+65,GHeight -112, "IF-Schleife(16)",1,0
		Text 580+65,GHeight -92, "Bug-Feature(20)",1,0
		Text 580+65,GHeight -72, "'ToDo-Tower(30)",1,0
		Text 580+65,GHeight -52, "Endlos-Schleife(50)",1,0
		
	Else
		Local t.TTower
		For t.TTower = Each TTower
			If t\mesh = Selected_Object Then
				SetFont font1
				Color 0,0,0
				
				Select t\typ
					Case 1:
						Text 425,GHeight -158, "GoTo Sprung"
						
					Case 2:
						Text 425,GHeight -158, "IF-Schleife"
					Case 3:
						Text 425,GHeight -158, "Bug-Feature"
					Case 4:
						Text 425,GHeight -158, "ToDo-Tower"
					Case 5:
						Text 425,GHeight -158, "Endlos-Schleife"
				End Select
				
				SetFont font2
				Color 200,0,0
				Text 425+53,GHeight -130, "unbegrenzt"
				Text 425+53,GHeight -110, "unbegrenzt"
				Text 425+53,GHeight -90, t\damage
				Text 425+53,GHeight -70, t\radius
				Text 425+53,GHeight -50, t\speed
				
				
				Color 180,180,210
				Rect 580,GHeight -160,130,20,1
				Color 90,130,90
				Rect 580,GHeight -160,130,20,0
				
				SetFont font1
				Color 0,0,0
				Text 585,GHeight -158, "Compile:"
				
				
				
				Color 180,180,210
				Rect 560,GHeight -136,160,30,1
				Color 90,130,90
				Rect 560,GHeight -136,160,30,0
				
				Local tmpc
				
				Select t\typ
					Case 1:
						tmpc=7
						Text 580+65,GHeight -132, "Upgrade zu If-Schleife(7)",1,0
					Case 2:
						tmpc=4
						Text 580+65,GHeight -132, "Upgrade zu Bug-Feature(4)",1,0
					Case 3:
						tmpc=10
						Text 580+65,GHeight -132, "Upgrade zu ToDo-Tower(10)",1,0
					Case 4:
						tmpc=20
						Text 580+65,GHeight -132, "Upgrade zu Endlos-Schleife(20)",1,0
					Case 5:
						tmpc=0
						Text 580+65,GHeight -132, "Kein Upgrade mglich",1,0
				End Select
				
				If RectsOverlap(MouseX(),MouseY(),3,3,560,GHeight -130,160,20) Then 
					Color 90,130,90
					Rect 560,GHeight -136,160,20,1
					If MH Then 
						If Money>=tmpc Then
							Select t\typ
								Case 1:
									FreeEntity t\mesh
									t\mesh = CreateCube()
									TurnEntity t\mesh,0,0,0
									EntityTexture t\mesh, IF_Tex
									EntityColor t\mesh,255,255,255
									ScaleEntity t\mesh, 1,.01,1
									EntityBox t\mesh,-.5,-.5,-.5,1,1,1
									
									t\typ = 2
									t\y = .1
									
									PositionEntity t\mesh,t\x,t\y,t\z
									t\radius = 20
									t\cost=16
									t\damage = 4
									t\speed = 1400
									
								Case 2:
									FreeEntity t\mesh
									t\mesh = CreateCube()
									TurnEntity t\mesh,0,0,0
									EntityTexture t\mesh, Bug_Tex
	;RotateEntity CurrentTower,90,0,0
									EntityColor t\mesh,255,255,255
									ScaleEntity t\mesh, 1,.01,1
									EntityBox t\mesh,-.5,-.5,-.5,1,1,1
									
									t\typ = 3
									t\y = .1
									
									PositionEntity t\mesh,t\x,t\y,t\z
									t\radius = 10
									t\cost=20
									t\damage = 9
									t\speed = 2000
								Case 3:
									FreeEntity t\mesh
									t\mesh = CreateCube()
									TurnEntity t\mesh,0,0,0
									EntityTexture t\mesh, ToDo_Tex
									EntityColor t\mesh,255,255,255
									ScaleEntity t\mesh, 1,.01,1
									EntityBox t\mesh,-.5,-.5,-.5,1,1,1
									
									t\typ = 4
									t\y = .1
									
									PositionEntity t\mesh,t\x,t\y,t\z
									t\radius = 30
									t\cost=30
									t\damage = 9
									t\speed = 600
								Case 4:
									FreeEntity t\mesh
									t\mesh = CreateCube()
									TurnEntity t\mesh,0,0,0
									EntityTexture t\mesh, Schleife_Tex
									RotateEntity t\mesh,90,0,0
									EntityColor t\mesh,255,255,255
									ScaleEntity t\mesh, 1,.01,1
									EntityBox t\mesh,-.5,-.5,-.5,1,1,1
									
									t\typ = 5
									t\y = 1
									
									t\radius = 15
									t\cost=50
									t\damage = 10
									t\speed = 1400
									PositionEntity t\mesh,t\x,t\y,t\z
							End Select
						EndIf
					EndIf
				EndIf
			EndIf
		Next
	EndIf
	
End Function


Function Scrolling()
	If MouseX() < 10 And EntityX(cam)> -70 Then TranslateEntity cam,FSpeed(-20),0,0
	If MouseX() > GWidth-20 And EntityX(cam) < 70 Then TranslateEntity cam,FSpeed(20),0,0
	
	If MouseY() < 20 And EntityZ(cam) < 65  Then TranslateEntity cam,0,0,FSpeed(20)
	If MouseY() > GHeight-5 And EntityZ(cam) > -65 Then TranslateEntity cam,0,0,FSpeed(-20)
	
	PositionEntity light,EntityX(cam),15,EntityZ(cam)
End Function

Function MiniMap()
	Color 50,200,50
	Rect 20,GHeight-160,170,150,1
	Color 50,50,50
	Rect 20,GHeight-160,170,150,0
	
	Color 150,70,70
	Rect 100,GHeight-78+45,10,10,1
	
	;Tower
	Color 255,255,0
	For t.TTower = Each TTower
		Rect 105+t\x,GHeight-78-t\y,3,3,1
	Next
	
	Color 150,150,150
	Rect 105+40,GHeight-80-50,8,8,1
	;Walls
	For w.TWall = Each TWall
		Color 20,20,0
		Rect 105+w\x,GHeight-78-w\y,3,3,1
	Next
	
	;Gegner
	For e.TEnemy = Each TEnemy
		Color 255,20,0
		Rect 105+e\x,GHeight-78-e\y,3,3,1
	Next
	
	;Builder
	Color 0,0,255
	Rect 104+EntityX(Builder),GHeight-78-EntityZ(Builder),3,3,1
	
	;MiniMap Scrolling
	MiniMap_x=-105+MouseX()
	MiniMap_Y=-(-GHeight+85+MouseY())
	
	If MiniMap_Y >-65 And MiniMap_Y < 66 And MiniMap_x > -71 And MiniMap_x < 71 Then
		If RectsOverlap(MouseX(),MouseY(),3,3,20,GHeight-160,170,150) And MD=1 Then PositionEntity cam, MiniMap_x,15,MiniMap_Y
	EndIf
	
	Rect 90+EntityX(cam),GHeight-95-EntityZ(cam),30,20,0
End Function

Function GetMap%(x,y)
	Return MMap(70+x,70+y)
End Function

Function SetMap(x,y,v)
	MMap(70+x,70+y)=v
End Function

Function MiniCam()
	If Selected_Object<>0 Then
		PositionEntity ObjectCam,EntityX(Selected_Object),3,EntityZ(Selected_Object)-2
	Else
		PositionEntity ObjectCam,0,-5,0
	EndIf
End Function
;~IDEal Editor Parameters:
;~C#Blitz3D