
Global menu_particle_x
Global menu_particle_incr=3
Function Menu()
	
	;Partikel-Effekt
	Local part.particle
	If pl_config<>Null Then
		If pl_config\amadeus Then
			For part=Each particle
				WritePixel part\x,part\y,part\col
				part\x=part\x+part\vx
				part\y=part\y+part\vy
				part\lifes=part\lifes+1
				If part\lifes>50 Then
					Delete part
				EndIf
			Next
			
			menu_particle_x=(menu_particle_x+menu_particle_incr)
			If menu_particle_x>200 Or menu_particle_x<0 Then
				menu_particle_incr=-menu_particle_incr
			EndIf
			
			For i=1 To 10
				c=Rand(200,255)
				cb=Rand(0,4)
				If cb=4 Then
					cb=1
				Else
					cb=0
				EndIf
				part=New particle
				part\col=c Shl 16+c Shl 8+cb*255
				part\x=menu_particle_x+(GWIDTH/2)-100
				part\y=35
				part\lifes=Rand(0,30)
				part\vx=Rnd(-2,2)
				part\vy=Rnd(-2,2)
			Next
		EndIf
	EndIf
	
	SetFont font_big
	Text GWIDTH/2+Rand(-1,1),20+Rand(-1,1),"Rock me Amadeus",1
	SetFont font_normal
	
	If MenuButton(GWIDTH/2-100,GHEIGHT/2-160,200,40,"Spielen") Then
		If pl_config=Null Then
			gamemode=MODE_GARAGE
		Else
			LoadTracks()
			gamemode=MODE_TRACK
		EndIf
	EndIf
	
	If MenuButton(GWIDTH/2-100,GHEIGHT/2-80,200,40,"Werkstatt") Then
		gamemode=MODE_GARAGE
	EndIf
	
	If MenuButton(GWIDTH/2-100,GHEIGHT/2,200,40,"Highscore") Then
		LoadTracks()
		PrepareHighscore()
		gamemode=MODE_HIGH
	EndIf
	
	If MenuButton(GWIDTH/2-100,GHEIGHT/2+80,200,40,"Editor") Then
		Editor_NewMap()
		scroll_x=0
		scroll_y=0
		gamemode=MODE_EDIT
	EndIf
	
	If MenuButton(GWIDTH/2-100,GHEIGHT/2+160,200,40,"Beenden") Then
		End
	EndIf
	
	Line 0,GHEIGHT-22,GWIDTH,GHEIGHT-22
	Text 5,GHEIGHT-20,"Spieler: "+game_playername$
	Text GWIDTH/2,GHEIGHT-20,"Geld: "+game_money+Chr(128),1
	txt$="Siege / Niederlagen: "+game_racewins+" / "+game_racenowin
	Text GWIDTH-StringWidth(txt$)-5,GHEIGHT-20,txt$
End Function

Function Garage()
	
	Text 105,10,"Modelle in Besitz",1
	Rect 5,5,200,GHEIGHT-65,0
	
	Text GWIDTH-105,10,"Spezial-Lackierungen",1
	Rect GWIDTH-205,5,200,GHEIGHT-65,0
	
	Text GWIDTH/2,10,"Farbe",1
	Rect GWIDTH/2-137,5,274,90,0
	
	Text GWIDTH/2,130,"Spezial-Farbe",1
	Rect GWIDTH/2-137,125,274,90,0
	
	Text GWIDTH/2,300,"Vorschau",1
	Rect GWIDTH/2-60,295,120,85,0
	
	If MenuButton(GWIDTH/2-95,GHEIGHT-50,190,40,"Fertig") Then
		SavePlayerConfig()
		gamemode=MODE_MENU
	EndIf
	
	If MenuButton(GWIDTH-200,GHEIGHT-50,190,40,"Leistung tunen") Then
		menu_selup=Null
		gamemode=MODE_TUNING
	EndIf
	
	If pl_config=Null Then Color 0,255,0
	If MenuButton(10,GHEIGHT-50,190,40,"Neuwagenkauf") Then
		gamemode=MODE_SHOP
	EndIf
	
	If pl_config=Null Then
		Tooltip("Du musst ein Auto erwerben")
		Return
	EndIf
	
	y=40
	x=55
	Local config.carconfig
	For config=Each carconfig
		If Not config\bot Then
			w=ImageWidth(config\preview)
			h=ImageHeight(config\preview)
			y=y+h/2
			
			DrawBlock config\preview,x,y
			
			If RectButton(x-w/2,y-h/2,w,h) Then
				pl_config=config
			EndIf
			
			If pl_config=config Then Rect x-w/2-2,y-h/2-2,w+4,h+4,0
			
			y=y+50-h/2
			If y>=GHEIGHT-65-h Then
				y=40
				x=x+100
			EndIf
		EndIf
	Next
	
	w=90
	h=40
	x=GWIDTH-105-w/2
	y=40
	Text GWIDTH-105,y+h/2,"(keine)",1,1
	If RectButton(x,y,w,h) Then
		pl_config\selpaint=0
	EndIf
	
	y=90
	For i=0 To 8
		If pl_config\car\paints[i]=0 Then Exit
		DrawBlock pl_config\car\paints[i],x,y
		
		w=ImageWidth(pl_config\car\paints[i])
		h=ImageHeight(pl_config\car\paints[i])
		If RectButton(x,y,w,h) Then
			pl_config\selpaint=i+1
		EndIf
		
		If pl_config\selpaint=i+1 Then Rect x-2,y-2,w+4,h+4,0
		
		y=y+50
	Next
	
	x=GWIDTH/2-127
	Color 200,0,0
	pl_config\r=MenuFader(x,40,255,pl_config\r-1,254)+1
	pl_config\pr=MenuFader(x,160,255,pl_config\pr-1,254)+1
	Color 0,200,0
	pl_config\g=MenuFader(x,60,255,pl_config\g-1,254)+1
	pl_config\pg=MenuFader(x,180,255,pl_config\pg-1,254)+1
	Color 0,0,200
	pl_config\b=MenuFader(x,80,255,pl_config\b-1,254)+1
	pl_config\pb=MenuFader(x,200,255,pl_config\pb-1,254)+1
	
	FreeImage pl_config\preview
	CreateCar(pl_config)
	DrawImage pl_config\preview,400,350
	
End Function

Global menu_seltrack.track
Function Trackmenu(flag)
	
	If menu_seltrack<>Null Then
		DrawBlock(menu_seltrack\preview,220,10)
	EndIf
	
	Text 105,10,"Verfgbare Strecken",1
	Rect 5,5,200,GHEIGHT-65,0
	
	Local track.track
	x=10
	y=30
	h=20
	w=190
	Local trackcount=0
	For track=Each track
		Text x,y+10,Left(track\name$,Len(track\name$)-4)
		
		If RectButton(x,y+h/2,w,h) Then
			menu_seltrack=track
		EndIf
		
		If menu_seltrack=track Then Rect x-2,y+h/2-2,w+4,h+4,0
		
		y=y+20
		trackcount=trackcount+1
	Next
	
	If MenuButton(10,GHEIGHT-50,190,40,"Zurck") Then
		If flag Then
			gamemode=MODE_MENU
		Else
			gamemode=MODE_EDIT
		EndIf
	EndIf
	
	If flag Then
		txt$="Just for Fun"
	Else
		txt$="Laden"
	EndIf
	If MenuButton(GWIDTH-200,GHEIGHT-50,190,40,txt$) Then
		If menu_seltrack<>Null Then
			If flag Then
				StartGame()
				racemode=RACE_FREE
				game_countdown=MilliSecs()
				gamemode=MODE_GAME
			Else
				LoadMap(menu_seltrack\name$)
				editor_MouseCheck=False
				gamemode=MODE_EDIT
			EndIf
		EndIf
	EndIf
	
	If flag Then
		If MenuButton(GWIDTH/2-95,GHEIGHT-50,190,40,"Karriererennen") Then
			racemode=RACE_CAREER
			num=Rand(1,trackcount)
			i=1
			For menu_seltrack=Each track
				If i=num Then Exit
				i=i+1
			Next
			game_lapstorace=Rand(3,8)
			game_playercount=Rand(3,6)
			StartGame()
			game_countdown=MilliSecs()
			gamemode=MODE_GAME
		EndIf
		
		If ctrl_mx>GWIDTH/2-95 And ctrl_mx<GWIDTH/2-95+190 Then
			If ctrl_my>GHEIGHT-50 And ctrl_my<GHEIGHT-50+40 Then
				Tooltip("Zufllige Map, Runden und Gegner")
			EndIf
		EndIf
		If ctrl_mx>GWIDTH-200 And ctrl_mx<GWIDTH-200+190 Then
			If ctrl_my>GHEIGHT-50 And ctrl_my<GHEIGHT-50+40 Then
				Tooltip("Ausgewhlte Map, Runden und Gegner")
			EndIf
		EndIf
		
		Text 220,GHEIGHT-85,"Runden: "+game_lapstorace
		Text 520,GHEIGHT-85,"Gegner: "+(game_playercount-1)
		Rect 210,GHEIGHT-90,GWIDTH-215,30,0
		
		game_lapstorace=MenuFader(300,GHEIGHT-75,150,game_lapstorace-1,9)+1
		game_playercount=MenuFader(600,GHEIGHT-75,150,game_playercount-1,5)+1
	EndIf
	
End Function

Global menu_selup.upgrade
Global menu_selup_index

Global menu_prev_maxspeed#
Global menu_prev_a#
Global menu_prev_brake#
Global menu_prev_wspeed#
Global menu_prev_handling#

Global menu_maxspeed#
Global menu_a#
Global menu_brake#
Global menu_wspeed#
Global menu_handling#

Function Tuning()
	
	Local up.upgrade
	
	Text 150,10,"Verfgbare Upgrades",1
	Rect 5,5,290,GHEIGHT-65,0
	
	Text GWIDTH-150,10,"Installierte Upgrades",1
	Rect GWIDTH-295,5,290,GHEIGHT-65,0
	
	Text 400,GHEIGHT-30,"Vorhandenes Geld: "+game_money+", Rennsiege: "+game_racewins,1,1
	
	If MenuButton(10,GHEIGHT-50,190,40,"Fertig") Then
		isAmadeus(pl_config)
		gamemode=MODE_GARAGE
	EndIf
	
	If pl_config=Null Then Return
	
	y=40
	x=10
	w=280
	h=20
	For up=Each upgrade
		If up\car=pl_config\car Then
			Text x,y,up\group$+" - "+up\name$
			
			If RectButton(x,y,w,h) Then
				menu_selup=up
				menu_selup_index=-1
			EndIf
			
			If menu_selup=up Then Rect x-2,y-2,w+4,h+4,0
			
			y=y+20
		EndIf
	Next
	
	y=40
	x=GWIDTH-290
	Local installed=False
	For i=0 To pl_config\installedups-1
		Text x,y,pl_config\upgrades[i]\group$+" - "+pl_config\upgrades[i]\name$
		
		If RectButton(x,y,w,h) Then
			menu_selup=pl_config\upgrades[i]
			menu_selup_index=i
		EndIf
		
		If menu_selup=pl_config\upgrades[i] Then
			installed=True
			Rect x-2,y-2,w+4,h+4,0
		EndIf
		
		y=y+20
	Next
	
	Text 400,10,"Ausgewhlt",1
	Rect 300,5,200,150,0
	If menu_selup<>Null Then
		If menu_selup_index=-1 Then
			Text 305,35,"Kosten: "+menu_selup\kosten+Chr(128)
			If installed Then
				Text 305,55,"Bereits gekauft"
			EndIf
			If menu_selup\neededWins>game_racewins Then
				Text 305,55,"Du musst noch "+(menu_selup\neededWins-game_racewins)+" Rennen"
				Text 305,75,"gewinnen um dieses"
				Text 305,95,"Upgrade zu erwerben!"
			ElseIf game_money>=menu_selup\kosten And (Not installed) Then
				If MenuButton(305,130,190,20,"Kaufen") Then
					ok=True
					For i=0 To pl_config\installedups-1
						If pl_config\upgrades[i]=menu_selup Then
							ok=False
							Exit
						EndIf
						If pl_config\upgrades[i]\group$=menu_selup\group$ Then
							game_money=game_money+(pl_config\upgrades[i]\kosten/2)
							game_money=game_money-menu_selup\kosten
							pl_config\upgrades[i]=menu_selup
							ok=False
							Exit
						EndIf
					Next
					
					If ok Then
						game_money=game_money-menu_selup\kosten
						pl_config\upgrades[pl_config\installedups]=menu_selup
						pl_config\installedups=pl_config\installedups+1
					EndIf
				EndIf
			EndIf
		Else
			Text 305,35,"Wert: "+(menu_selup\kosten/2)+Chr(128)
			
			If MenuButton(305,130,190,20,"Verkaufen") Then
				game_money=game_money+(menu_selup\kosten/2)
				For i=menu_selup_index To pl_config\installedups-2
					pl_config\upgrades[i]=pl_config\upgrades[i+1]
				Next
				pl_config\upgrades[pl_config\installedups-1]=Null
				pl_config\installedups=pl_config\installedups-1
				menu_selup=Null
			EndIf
		EndIf
	EndIf
	
	Text 400,215,"Leistungswerte",1
	Rect 300,210,200,GHEIGHT-270,0
	
	;Standardwerte
	menu_prev_maxspeed#=0
	menu_prev_a#=0
	menu_prev_brake#=0
	menu_prev_wspeed#=0
	menu_prev_handling#=0
	
	menu_maxspeed#=pl_config\car\maxspeed
	menu_a#=pl_config\car\a
	menu_brake#=pl_config\car\brake
	menu_wspeed#=pl_config\car\wspeed
	menu_handling#=pl_config\car\handling
	
	Color 100,100,100
	TuningBars()
	
	;+ Upgrades
	If pl_config\installedups<>0 Then
		menu_prev_maxspeed=menu_maxspeed
		menu_prev_a=menu_a
		menu_prev_brake=menu_brake
		menu_prev_wspeed=menu_wspeed
		menu_prev_handling=menu_handling
		
		For i=0 To pl_config\installedups-1
			menu_maxspeed=menu_maxspeed+pl_config\car\maxspeed*(pl_config\upgrades[i]\up[0]/100.0)
			menu_a=menu_a+pl_config\car\a*(pl_config\upgrades[i]\up[1]/100.0)
			menu_brake=menu_brake+pl_config\car\brake*(pl_config\upgrades[i]\up[2]/100.0)
			menu_wspeed=menu_wspeed+pl_config\car\wspeed*(pl_config\upgrades[i]\up[3]/100.0)
			menu_handling=menu_handling-pl_config\car\handling*(pl_config\upgrades[i]\up[4]/100.0)
		Next
		
		Color 0,130,0
		TuningBars()
	EndIf
	
	;+ Ausgewhltes Upgrade
	If menu_selup<>Null And menu_selup_index=-1 Then
		
		menu_prev_maxspeed=menu_maxspeed
		menu_prev_a=menu_a
		menu_prev_brake=menu_brake
		menu_prev_wspeed=menu_wspeed
		menu_prev_handling=menu_handling
		
		ok=True
		For i=0 To pl_config\installedups-1
			If pl_config\upgrades[i]=menu_selup Then
				ok=False
				Exit
			EndIf
			If pl_config\upgrades[i]\group$=menu_selup\group$ Then
				menu_maxspeed=menu_maxspeed-pl_config\car\maxspeed*(pl_config\upgrades[i]\up[0]/100.0)
				menu_a=menu_a-pl_config\car\a*(pl_config\upgrades[i]\up[1]/100.0)
				menu_brake=menu_brake-pl_config\car\brake*(pl_config\upgrades[i]\up[2]/100.0)
				menu_wspeed=menu_wspeed-pl_config\car\wspeed*(pl_config\upgrades[i]\up[3]/100.0)
				menu_handling=menu_handling+pl_config\car\handling*(pl_config\upgrades[i]\up[4]/100.0)
				Exit
			EndIf
		Next
		
		If ok Then
			menu_maxspeed=menu_maxspeed+pl_config\car\maxspeed*(menu_selup\up[0]/100.0)
			menu_a=menu_a+pl_config\car\a*(menu_selup\up[1]/100.0)
			menu_brake=menu_brake+pl_config\car\brake*(menu_selup\up[2]/100.0)
			menu_wspeed=menu_wspeed+pl_config\car\wspeed*(menu_selup\up[3]/100.0)
			menu_handling=menu_handling-pl_config\car\handling*(menu_selup\up[4]/100.0)
			
			Color 0,255,0
			TuningBars()
		EndIf
	EndIf
	
	txt$=""
	If ctrl_my>230 And ctrl_my<GHEIGHT-65 Then
		If ctrl_mx>315 And ctrl_mx<335 Then
			txt$="Topspeed: "+(menu_maxspeed*20)
		EndIf
		If ctrl_mx>345 And ctrl_mx<365 Then
			txt$="Beschleunigung: "+(menu_a*100)
		EndIf
		If ctrl_mx>375 And ctrl_mx<395 Then
			txt$="Bremsen: "+(menu_brake*100)
		EndIf
		If ctrl_mx>405 And ctrl_mx<425 Then
			txt$="Lenkstrke: "+menu_wspeed
		EndIf
		If ctrl_mx>435 And ctrl_mx<455 Then
			txt$="Verlust in Kurven: "+(menu_handling*1000)
		EndIf
	EndIf
	
	Tooltip(txt$)
End Function

Function TuningBars()
	If menu_prev_maxspeed<>menu_maxspeed Then
		Rect 315,GHEIGHT-70-menu_maxspeed*10,20,(menu_maxspeed-menu_prev_maxspeed)*10,1
	EndIf
	If menu_prev_a<>menu_a Then
		Rect 345,GHEIGHT-70-menu_a*4000,20,(menu_a-menu_prev_a)*4000
	EndIf
	If menu_prev_brake<>menu_brake Then
		Rect 375,GHEIGHT-70-menu_brake*4000,20,(menu_brake-menu_prev_brake)*4000
	EndIf
	If menu_prev_wspeed<>menu_wspeed Then
		Rect 405,GHEIGHT-70-menu_wspeed*40,20,(menu_wspeed-menu_prev_wspeed)*40
	EndIf
	If menu_prev_handling<>menu_handling Then
		If menu_prev_handling>menu_handling Then
			Rect 435,GHEIGHT-70-menu_prev_handling*20000,20,(menu_prev_handling-menu_handling)*20000
		Else
			Rect 435,GHEIGHT-70-menu_handling*20000,20,(menu_handling-menu_prev_handling)*20000
		EndIf
	EndIf
End Function

Global menu_selconfig.carconfig
Global menu_selcar.car
Function CarShop()
	Local config.carconfig
	
	Text 10,10,"Erhltliche Modelle"
	Rect 5,5,200,GHEIGHT-65,0
	
	Text GWIDTH-105,10,"Modelle in Besitz",1
	Rect GWIDTH-205,5,200,GHEIGHT-65,0
	
	If MenuButton(GWIDTH/2-95,GHEIGHT-50,190,40,"Fertig") Then
		gamemode=MODE_GARAGE
	EndIf
	
	If MenuButton(10,GHEIGHT-50,190,40,"Kaufen") Then
		If menu_selcar<>Null Then
			If game_money>=menu_selcar\kosten Then
				game_money=game_money-menu_selcar\kosten
				config=New carconfig
				config\car=menu_selcar
				config\r=255
				config\g=255
				config\b=255
				CreateCar(config)
				pl_config=config
			EndIf
		EndIf
	EndIf
	
	If MenuButton(GWIDTH-200,GHEIGHT-50,190,40,"Verkaufen") Then
		If menu_selconfig<>Null Then
			game_money=game_money+menu_selconfig\car\kosten/2
			For i=0 To menu_selconfig\installedups-1
				game_money=game_money+menu_selconfig\upgrades[i]\kosten/2
			Next
			Delete menu_selconfig
		EndIf
	EndIf
	
	Text 400,10,"Vorhandenes Geld: "+game_money+Chr(128),1
	
	Local car.car
	y=40
	x=15
	For car=Each car
		DrawBlock car\img,x,y
		
		w=ImageWidth(car\img)
		h=ImageHeight(car\img)
		If RectButton(x,y,w,h) Then
			menu_selcar=car
		EndIf
		
		If menu_selcar=car Then Rect x-2,y-2,w+4,h+4,0
		
		y=y+50
		If y>=GHEIGHT-65-h Then
			y=40
			x=x+100
		EndIf
	Next
	
	y=40
	x=GWIDTH-155
	For config=Each carconfig
		If Not config\bot Then
			w=ImageWidth(config\preview)
			h=ImageHeight(config\preview)
			y=y+h/2
			
			DrawBlock config\preview,x,y
			
			If RectButton(x-w/2,y-h/2,w,h) Then
				menu_selconfig=config
			EndIf
			
			If menu_selconfig=config Then Rect x-w/2-2,y-h/2-2,w+4,h+4,0
			
			y=y+50-h/2
			If y>=GHEIGHT-65-h Then
				y=40
				x=x+100
			EndIf
		EndIf
	Next
	
	Text 400,200,"Ausgewhlt",1
	Rect GWIDTH/2-90,190,180,270,0
	If menu_selcar<>Null Then
		Text 400,220,Chr(34)+menu_selcar\name$+Chr(34),1
		Text 400,240,"Kosten: "+menu_selcar\kosten+Chr(128),1
		
		Color 100,100,100
		Rect GWIDTH/2-70,450-menu_selcar\maxspeed*10,20,menu_selcar\maxspeed*10,1
		Rect GWIDTH/2-40,450-menu_selcar\a*4000,20,menu_selcar\a*4000
		Rect GWIDTH/2-10,450-menu_selcar\brake*4000,20,menu_selcar\brake*4000
		Rect GWIDTH/2+20,450-menu_selcar\wspeed*40,20,menu_selcar\wspeed*40
		Rect GWIDTH/2+50,450-menu_selcar\handling*10000,20,menu_selcar\handling*10000
		
		txt$=""
		If ctrl_my>240 And ctrl_my<450 Then
			If ctrl_mx>GWIDTH/2-70 And ctrl_mx<GWIDTH/2-50 Then
				txt$="Topspeed: "+(menu_selcar\maxspeed*20)
			EndIf
			If ctrl_mx>GWIDTH/2-40 And ctrl_mx<GWIDTH/2-20 Then
				txt$="Beschleunigung: "+(menu_selcar\a*100)
			EndIf
			If ctrl_mx>GWIDTH/2-10 And ctrl_mx<GWIDTH/2+10 Then
				txt$="Bremsen: "+(menu_selcar\brake*100)
			EndIf
			If ctrl_mx>GWIDTH/2+20 And ctrl_mx<GWIDTH/2+40 Then
				txt$="Lenkstrke: "+menu_selcar\wspeed
			EndIf
			If ctrl_mx>GWIDTH/2+50 And ctrl_mx<GWIDTH/2+70 Then
				txt$="Verlust in Kurven: "+(menu_selcar\handling*1000)
			EndIf
		EndIf
		
		Tooltip(txt$)
	EndIf
	
End Function

Function Tooltip(txt$)
	If txt$<>"" Then
		BGText(ctrl_mx-StringWidth(txt$)-4,ctrl_my,txt$,0,0,True)
	EndIf
End Function

Function RectButton(x,y,w,h)
	If ctrl_mx>x And ctrl_mx<x+w Then
		If ctrl_my>y And ctrl_my<y+h Then
			Rect x-2,y-2,w+4,h+4,0
			If ctrl_mhit Then Return True
		EndIf
	EndIf
	Return False
End Function

Function MenuButton(x,y,w,h,txt$)
	Rect x,y,w,h,0
	Text x+w/2,y+h/2,txt$,1,1
	If ctrl_mx>x And ctrl_mx<x+w Then
		If ctrl_my>y And ctrl_my<y+h Then
			
			Rect x+1,y+1,w-2,h-2,0
			If ctrl_mhit Then
				Return True
			EndIf
		EndIf
	EndIf
	Return False
End Function

Function MenuFader(x,y,w,val#,maxval)
	If val<0 Then val=0
	If val>maxval Then val=maxval
	Line x,y,x+w,y
	Oval x+(val/maxval)*w-3,y-5,6,10,1
	If ctrl_mx>=x And ctrl_mx<=x+w Then
		If ctrl_my>=y-5 And ctrl_my<=y+5 Then
			If MouseDown(1) Then
				Return ((ctrl_mx-x)/Float(w))*maxval
			EndIf
		EndIf
	EndIf
	Return val#
End Function

Function LoadCars()
	Local dir=ReadDir("cars")
	Local file$,reader
	Local pdir,f$
	Local car.car
	Local up.upgrade
	Repeat
		file$=NextFile(dir)
		If file$="" Then Exit
		If FileType("cars\"+file$)=2 And file$<>"." And file$<>".." Then
			car=New car
			car\name$=file$
			car\img=LoadImage("cars\"+file$+"\body.png")
			If car\img=0 Then
				Delete car
			Else
				reader=ReadFile("cars\"+file$+"\physic.dat")
				If reader=0 Then
					Delete car
				Else
					car\maxspeed=ReadFloat(reader)
					car\a=ReadFloat(reader)
					car\brake=ReadFloat(reader)
					car\wspeed=ReadFloat(reader)
					car\handling=ReadFloat(reader)
					
					Local VertCount=ReadByte(reader)
					car\body=New TEntity
					While Not Eof(reader)
						x=ReadByte(reader)
						y=ReadByte(reader)
						CreateVertex(car\body,x,y,1/Float(VertCount))
					Wend
					CloseFile reader
					
					InitEntity(car\body)
					car\body\Deactivate=True
					
					pdir=ReadDir("cars\"+file$+"\paints")
					If pdir<>0 Then
						i=0
						Repeat
							f$=NextFile(pdir)
							If f$="" Then Exit
							If Right(f$,4)=".png" Then
								car\paints[i]=LoadImage("cars\"+file$+"\paints\"+f$)
								i=i+1
							EndIf
						Forever
						CloseDir pdir
					EndIf
					
					reader=ReadFile("cars\"+file$+"\upgrades.dat")
					If reader<>0 Then
						car\kosten=ReadInt(reader)
						While Not Eof(reader)
							group$=ReadLine(reader)
							count=ReadByte(reader)
							For i=1 To count
								up=New upgrade
								up\group$=group$
								up\car=car
								up\name$=ReadLine(reader)
								up\kosten=ReadShort(reader)
								up\neededWins=ReadByte(reader)
								For j=0 To 4
									up\up[j]=ReadByte(reader)
								Next
							Next
						Wend
						CloseFile reader
					EndIf
				EndIf
			EndIf
		EndIf
	Forever
	CloseDir dir
End Function

Function LoadTracks()
	StatusMessage("Strecken erfassen...")
	Local track.track
	Local reader
	Local temp,tile.tile
	Local factorx,factory
	
	For track=Each track
		FreeImage track\preview
		Delete track
	Next
	
	Local dir=ReadDir("tracks")
	Local file$
	Repeat
		file$=NextFile(dir)
		If file$="" Then Exit
		If FileType("tracks\"+file$)=1 Then
			track=New track
			track\name$=file$
			
			reader=ReadFile("tracks\"+file$)
			map_w=ReadByte(reader)
			map_h=ReadByte(reader)
			ReadByte(reader)
			ReadByte(reader)
			Dim map(map_w,map_h)
			
			While Not Eof(reader)
				For y=0 To map_h-1
					For x=0 To map_w-1
						temp=ReadByte(reader)
						For tile=Each tile
							If tile\id=temp Then
								map(x,y)=tile
								Exit
							EndIf
						Next
					Next
				Next
			Wend
			CloseFile reader
			
			w=map_w*50
			h=map_h*50
			If w>GWIDTH-200 Then w=GWIDTH-200
			If h>GHEIGHT-110 Then h=GHEIGHT-110
			track\preview=CreateImage(w,h)
			factorx=40/map_w
			factory=40/map_h
			SetBuffer ImageBuffer(track\preview)
			For y=0 To map_h-1
				For x=0 To map_w-1
					If map(x,y)<>Null Then
						DrawBlock map(x,y)\prev,x*50,y*50
					EndIf
				Next
			Next
		EndIf
	Forever
	SetBuffer BackBuffer()
	CloseDir dir
End Function

Function SavePlayerConfig()
	Local writer=WriteFile("player.dat")
	WriteInt(writer,game_money)
	WriteShort(writer,game_racewins)
	WriteShort(writer,game_racenowin)
	WriteString(writer,game_playername$)
	Local config.carconfig
	For config=Each carconfig
		If Not config\bot Then
			WriteByte(writer,config\r)
			WriteByte(writer,config\g)
			WriteByte(writer,config\b)
			WriteByte(writer,config\pr)
			WriteByte(writer,config\pg)
			WriteByte(writer,config\pb)
			WriteByte(writer,config\selpaint)
			
			WriteString(writer,config\car\name$)
			
			WriteByte(writer,config\installedups)
			For i=0 To config\installedups-1
				WriteString(writer,config\upgrades[i]\group$)
				WriteString(writer,config\upgrades[i]\name$)
			Next
		EndIf
	Next
	CloseFile writer
End Function

Function LoadPlayerConfig()
	Local config.carconfig
	Local car.car
	Local up.upgrade
	Local temp$
	Local reader=ReadFile("player.dat")
	If reader<>0 Then
		game_money=ReadInt(reader)
		game_racewins=ReadShort(reader)
		game_racenowin=ReadShort(reader)
		game_playername$=ReadString(reader)
		While Not Eof(reader)
			config=New carconfig
			config\r=ReadByte(reader)
			config\g=ReadByte(reader)
			config\b=ReadByte(reader)
			config\pr=ReadByte(reader)
			config\pg=ReadByte(reader)
			config\pb=ReadByte(reader)
			config\selpaint=ReadByte(reader)
			
			temp$=ReadString(reader)
			For car=Each car
				If car\name$=temp Then
					config\car=car
					Exit
				EndIf
			Next
			
			config\installedups=ReadByte(reader)
			For i=0 To config\installedups-1
				group$=ReadString(reader)
				name$=ReadString(reader)
				For up=Each upgrade
					If up\car=config\car Then
						If up\group$=group$ And up\name$=name$ Then
							config\upgrades[i]=up
							Exit
						EndIf
					EndIf
				Next
			Next
			
			CreateCar(config)
		Wend
		CloseFile reader
		Return True
	EndIf
	Return False
End Function

Function GameMenu()
	MouseInput()
	
	Color 0,0,0
	Rect GWIDTH/2-70,GHEIGHT/2-55,140,110,1
	Color 200,0,0
	Rect GWIDTH/2-70,GHEIGHT/2-55,140,110,0
	Color 255,255,255
	
	Local diff
	Local player.player
	If MenuButton(GWIDTH/2-65,GHEIGHT/2-50,130,30,"Forsetzen") Then
		gamemode=MODE_GAME
		;Zeitkorrektur
		diff=global_time-game_pause_time
		For player=Each player
			player\lap_timer=player\lap_timer+diff
			player\bot_timer=player\bot_timer+diff
		Next
		If game_countdown<>-1 Then
			game_countdown=game_countdown+diff
		EndIf
		game_starttime=game_starttime+diff
	EndIf
	
	Local tile.tile
	If MenuButton(GWIDTH/2-65,GHEIGHT/2-15,130,30,"Neustart") Then
		;Positionen "manuell" zuweisen
		tile.tile=map(map_start_x,map_start_y)
		If tile\dir1[1]=DIR_RIGHT Then
			w=0
		ElseIf tile\dir1[1]=DIR_DOWN Then
			w=270
		EndIf
		i=0
		For player=Each player
			player\w=w
			PositionPhysEntity(player\body,map_start_x*tile_size+tile_size/2+startpos(i,0),map_start_y*tile_size+tile_size/2+startpos(i,1))
			i=i+1
		Next
		
		gamemode=MODE_GAME
		game_countdown=global_time
		
		StartConditions()
	EndIf
	
	If MenuButton(GWIDTH/2-65,GHEIGHT/2+20,130,30,"Aufgeben") Then
		gamemode=MODE_MENU
	EndIf
End Function

Function isAmadeus(config.carconfig)
	If config=Null Then Return
	Local up.upgrade
	Local soll=0
	For up=Each upgrade
		If up\car=config\car Then
			If Instr(up\name$,"Amadeus")>0 Then soll=soll+1
		EndIf
	Next
	Local ist=0
	For i=0 To config\installedups-1
		If Instr(config\upgrades[i]\name$,"Amadeus")>0 Then ist=ist+1
	Next
	config\amadeus=(soll=ist)
End Function

;~IDEal Editor Parameters:
;~F#3#54#BD#129#1F7#20F#289#28F#299#2A8#2B7#306#346#363#396#3CA
;~C#Blitz3D