;Bewegungen

;Schsse Bewegen
Function MoveShoot()
	
	;Alle Schsse des Spielers durchgehen:
	For Schuss.TSchussSpieler = Each TSchussSpieler
		
		Schuss\XPos# = SChuss\XPos# + Schuss\Speed# ;Position ndern
		
		;Frames ndern:
		If ((Schuss\Image\Frametimer + Schuss\Image\FrameStart) < MilliSecs()) Then
			If Schuss\Image\MaxFrame > 0 Then
				Schuss\Image\Frame = (Schuss\Image\Frame+1)Mod Schuss\Image\MaxFrame
			EndIf
			Schuss\Image\FrameStart = MilliSecs()
		EndIf
		;/
		
		If Schuss\XPos > 1030 Then Schuss\Dead = 1
		If Schuss\Dead = 1 Then Delete Schuss.TschussSpieler ;lschen
		
	Next
	;/
	
	;Alles gegnerischen Schsse durchgehen:
	For SchussGegner.TSchussGegner = Each TSchussGegner
		
		SchussGegner\XPos# = SchussGegner\XPos# - SchussGegner\Speed# ;Position ndern
		
		;Frames ndern:
		If ((SchussGegner\Image\Frametimer + SchussGegner\Image\FrameStart) < MilliSecs()) Then
			If SchussGegner\Image\MaxFrame > 0 Then
				SchussGegner\Image\Frame = (SchussGegner\Image\Frame + 1)Mod SchussGegner\Image\MaxFrame
			EndIf
			SchussGegner\Image\FrameStart = MilliSecs()
		EndIf
		;/
		
		If SchussGegner\XPos# < -20 Then SchussGegner\Dead = 1
		If SchussGegner\Dead = 1 Then Delete SchussGegner.TschussGegner ;lschen
		
	Next
	;/
	
End Function
;/

;Partikel bewegen:
Function MovePartikel()
	
	;Jeden Partikel durchgehen:
	For Partikel.TPartikel = Each TPartikel
		
		;Position ndern:
		Partikel\YSpeed# = Partikel\YSpeed# + Gravity#
		Partikel\XPos# = Partikel\XPos# + Partikel\XSpeed#
		Partikel\YPos# = Partikel\YPos# + Partikel\YSpeed#
		;/
		
		If Partikel\XPos# > GraphicsWidth() Then Partikel\Dead = 1
		If Partikel\XPos# > GraphicsHeight() Then Partikel\Dead = 1
		If ((Partikel\Startzeit# + Partikel\Lebensdauer#) < MilliSecs()) Then
			Partikel\Dead = 1
		EndIf
		
		If Partikel\Dead = 1 Then Delete Partikel.TPartikel ;lschen
		
	Next
	;/
	
End Function
;/

;Pythagoras um Entfernungen zu berechnen:
Function Pythagoras(x1#, y1#, x2#, y2#)
	Return Sqr((x1#-x2#)^2 + (y1#-y2#)^2)
End Function
;/


;Gegner bewegen
Function MoveEnemy()
	
	;Jeden Gegner durchgehen:
	For Gegner.TGegner = Each TGegner
		
		;Frames ndern:
		If ((Gegner\Image\FrameTimer + Gegner\Image\FrameStart) < MilliSecs()) Then
			Gegner\Image\Frame = (Gegner\Image\Frame + 1)Mod Gegner\Image\MaxFrame
			Gegner\Image\FrameStart = MilliSecs()
		EndIf
		;/
		
		;Schsse erstellen, wenn die Zeit stimmt:
		If ((Gegner\SchussTimer + Gegner\SchussStart) < MilliSecs()) Then
			If Gegner\Level < 3 Then
				If ((Gegner\YPos#-40 < Spieler\YPos#) And (Gegner\YPos#+40 > Spieler\YPos#)) Then
					Gegner\SchussStart = MilliSecs()
					SetShootEnemy(Gegner.TGegner)
				EndIf
			Else
				Gegner\SchussStart = MilliSecs()
				SetShootEnemy(Gegner.TGegner)
			EndIf
		EndIf
		;/
		
		Gegner\XPos# = Gegner\XPos# - Gegner\Speed# ;Position ndern
		
		If Gegner\XPos# < -30 Then Gegner\Dead = 1
		If Gegner\Dead = 1 Then Delete Gegner.TGegner ;lschen
		
	Next
	;
	
End Function
;/


;Geld bewegen:
Function MoveGeld()
	
	;Jeden Eintrag im Geld Type durchgehen:
	For Geld.TGeld = Each TGeld
		
		Geld\XPos# = Geld\XPos# - Geld\Speed# ;Position ndern
		
		;Frames ndern:
		If ((Geld\Image\FrameStart + Geld\Image\FrameTimer) < MilliSecs()) Then
			Geld\Image\Frame = (Geld\Image\Frame+1)Mod Geld\Image\MaxFrame
			Geld\Image\FrameStart = MilliSecs()
		EndIf
		;/
		
		If Geld\XPos# < -10 Then Geld\Dead = 1
		If Geld\Dead = 1 Then Delete Geld.TGeld ;lschen
		
	Next
	;/
	
End Function
;/
;~IDEal Editor Parameters:
;~F#31#4B#52#79
;~C#Blitz3D