;Set Funtkionen

Dim ZufallsListe(999)

;Das Level initialisieren und bewegen
Function SetLevel() 
	
	If SchiebNr < 1 Then 
		Bild1 = Wiese
		Bild2 = ZaunM2
	EndIf
	If SchiebNr = 1 Then
		Bild1 = ZaunM2
		Bild2 = ZaunM1
	EndIf
	If SchiebNr = 2 Then
		Bild1 = ZaunM1
		Bild2 = ZaunM2
	EndIf
	If SchiebNr = 3 Then
		Bild1 = ZaunM2
		Bild2 = Wiese
	EndIf
	
End Function
;/

;Partikel erstellen:
Function SetPartikelExplo(Gegner.TGegner)
	
	Local Anzahl = Rand(50, 140)
	
	For i = 1 To Anzahl
		
		Partikel.TPartikel = New TPartikel
		
		
		Partikel\XPos# = (Gegner\XPos#)
		Partikel\YPos# = (Gegner\YPos#)
		Partikel\Winkel# = Rand(0,360)
		Partikel\Speed# = Rnd(3, 4)
		Partikel\XSpeed# = Cos(Partikel\Winkel#) * Partikel\Speed#
		Partikel\YSpeed# = Sin(Partikel\Winkel#) * Partikel\Speed#
		Partikel\Rot = Rand(200, 255)
		Partikel\Gruen = Rand(10, 50)
		Partikel\Blau = Rand(10, 50)
		Partikel\Startzeit# = MilliSecs()
		Partikel\Lebensdauer# = Rand(200, 600)
		Partikel\Dead = 0
		
	Next
	
End Function
;/

;Upgrades erstellen:
Function SetUpgrades()
	
	
	For VorlageUpgrade.TVorlageUpgrade = Each TVorlageUpgrade
		For i = 1 To 3
			If i = VorlageUpgrade\ID Then
				Upgrade.TUpgrade = New TUpgrade
				Upgrade\Kosten = VorlageUpgrade\Kosten
				Upgrade\Nr = 0
				UpGrade\ID = VorlageUpGrade\ID
				UpGrade\Menge# = VorlageUpgrade\Menge#
			EndIf
		Next
	Next
	
End Function
;/

;Gegner erstellen
Function SetEnemy(LevelNow)
	
	
	Local AnzahlVorlage%
	Local Anzahl% = Rand(1,3)
	Local Zufall%
	
	;Alle Gegnertypen zur Auswahlliste hinzufgen:
	For VorlageGegner.TVorlageGegner = Each TVorlageGegner
		If VorlageGegner\ID <= LevelNow Then
			AnzahlVorlage = AnzahlVorlage + 1
			ZufallsListe(AnzahlVorlage) = VorlageGegner\Nr
		EndIf
	Next
	;/
	
	
	For i = 1 To Anzahl ;Gegner erstellen
			
			Gegner.TGegner = New TGegner
			Gegner\XPos# = 1300
			Versuche = 0
			Repeat
				
				Gegner\YPos# = Rand(34, 727)
				
				For info.TGegner = Each TGegner
					If info <> Gegner Then
						;Gegner weit genug voneinander entfernen:
						If Pythagoras(Gegner\XPos#, Gegner\YPos#, info\XPos#, info\YPos#) < 70 Then
							ZuNah = ZuNah + 1
						EndIf
						;/
						Versuche = Versuche + 1
					EndIf
				Next
				
			Until Versuche > 600 Or ZuNah = False
			
			
			Zufall = Rand(1,AnzahlVorlage);ZufallsZahl angeben
			
			;Gegner nach Vorlage erstellen:
			For VorlageGegner.TVorlageGegner = Each TVorlageGegner 
				If VorlageGegner\Nr = ZufallsListe(Zufall) Then ;Einen zuflligen Gegner auswhlen
					Gegner\Image = VorlageGegner\Image
					Gegner\Level = VorlageGegner\Level + (Rand(0, LevelNow));Den Level einstellen
					Gegner\Erfahrung = VorlageGegner\Erfahrung + (Gegner\Level*5) ;Erfahrunfg nach Level berechnen
					Gegner\Energie# = VorlageGegner\Energie# + (Gegner\Level*7) ;Energie nach Level berechnen
					Gegner\Speed# = VorlageGegner\Speed#
					Gegner\SchussTimer = VorlageGegner\SchussTimer + Rand(100,400)
					Gegner\ID = VorlageGegner\ID
				EndIf
			Next
			;/
			
			Gegner\Dead = 0
			Gegner\SchussStart = MilliSecs()
			Gegner\Image\FrameStart = MilliSecs()
			
	Next
	GegnerStart = MilliSecs()
	
	
End Function
;/

;Schuss fr einen Gegner erstellen, der diese Funktion aufruft:
Function SetShootEnemy(Gegner.TGegner)

	SchussGegner.TSchussGegner = New TSchussGegner
	SchussGegner\XPos# = Gegner\XPos# - (ImageWidth(Gegner\Image\Image)/2)
	SchussGegner\YPos# = Gegner\YPos#

	For VorlageSchussGegner.TVorlageSchussGegner = Each TVorlageSchussGegner
	
		If VorlageSchussGegner\ID = Gegner\ID Then ;zugehrige ID
		
			SchussGegner\Speed# = VorlageSchussGegner\Speed#
			SchussGegner\Kraft = VorlageSchussGegner\Kraft + Gegner\Level*5 ;Kraft nach Level berechnen
			SchussGegner\Image = VorlageSchussGegner\Image
			SchussGegner\Dead = 0
		
		EndIf
	
	
	Next
	
	SchussGegner\Image\FrameStart = MilliSecs()

End Function
;/

;Schsse fr den Spieler erstellen:
Function SetShootPlayer(Level)
	
	Schuss.TSchussSpieler = New TSchussSpieler
	Schuss\XPos# = Spieler\XPos# + 27
	Schuss\YPos# = Spieler\YPos# + 40
	
	For VorlageSchussSpieler.TVorlageSchussSpieler = Each TVorlageSchussSpieler
		
		
		If VorlageSchussSpieler\ID = Spieler\SchussLevel Then
			
				Schuss\Speed# = VorlageSchussSpieler\Speed#
				Schuss\Image = VorlageSchussSpieler\Image
				Schuss\ID = VorlageSchussSpieler\ID
				Schuss\Kraft# = VorlageSchussSpieler\Kraft# + (Spieler\Level * 10)
					
					
		EndIf
	Next
	
	Schuss\Dead = 0
	Schuss\Image\FrameStart = MilliSecs()
	
;	If ((Spieler\BigTime+Spieler\BigTimeStart) < MilliSecs()) Then
;		
;		Schuss.TSchussSpieler = New TSchussSpieler
;		Schuss\XPos# = Spieler\XPos# + 20
;		Schuss\YPos# = Spieler\YPos#
;		
;		For VorlageSchussSpieler.TVorlageSchussSpieler = Each TVorlageSchussSpieler
;			
;			
;			If VorlageSchussSpieler\ID = Spieler\SchussLevel*3 Then
;				
;				Schuss\Speed# = VorlageSchussSpieler\Speed#
;				Schuss\Image = VorlageSchussSpieler\Image
;				Schuss\ID = VorlageSchussSpieler\ID
;				Schuss\Kraft# = VorlageSchussSpieler\Kraft#
;				
;			EndIf
;			
;		Next
;		
;		Schuss\Dead = 0
;		Schuss\Image\FrameStart = MilliSecs()
;		
;		Spieler\BigtimeStart = MilliSecs()
;		
;	EndIf
				
	
End Function
;/


;Geld erstellen an der Position eines Gegners:
Function CreateGeld.TGeld(Gegner.TGegner)

	Geld.TGeld = New TGeld

	Geld\XPos# = Gegner\XPos#
	Geld\YPos# = Gegner\YPos#

	For VorlageGeld.TVorlageGeld = Each TVorlageGeld
		If VorlageGeld\ID = 1 Then
		
			Geld\Image = VorlageGeld\Image
			Geld\Speed# = VorlageGeld\Speed#
			Geld\Menge = VorlageGeld\Menge + Gegner\Level*0.5
		
		EndIf
	Next

	Geld\Dead = 0

End Function
;/


;Funktion um Bilder zu erstellen (Types):
Function BildErstellen.TImage(Image, MaxFrame, FrameTime)
	
	Local i.TImage = New TImage
	i\Image = Image
	i\MaxFrame = MaxFrame
	i\FrameTimer = FrameTime
	Return i
	
End Function
;/
;~IDEal Editor Parameters:
;~F#5#1C#38#4B#8F#A9#E1#F9
;~C#Blitz3D