;Vorlagen erstellen

Type TVorlageGegner
	Field ID
	Field Nr
	Field Erfahrung, Level
	Field Speed#
	Field SchussTimer
	Field Image.TImage
	Field Energie#
	Field Dead
End Type

Type TVorlageSchussGegner
	Field ID
	Field Speed#
	Field Image.TImage
	Field Kraft
End Type

Type TVorlageSchussSpieler
	Field ID
	Field Kraft#
Field Speed#
Field Image.TImage
End Type

Type TVorlageGeld
	Field ID
	Field Image.TImage
	Field Menge#
	Field Speed#
End Type

Type TVorlageUpgrade
	Field ID
	Field Kosten
	Field Menge#
End Type

Function UpgradeVorlage()
	
	VorlageUpgrade = New TVorlageUpgrade
	VorlageUpgrade\ID = 1 ;Geschwindigkeit
	VorlageUpgrade\Kosten = 45
	VorlageUpgrade\Menge = 0.3
	
	VorlageUpgrade = New TVorlageUpgrade
	VorlageUpgrade\ID = 2 ;SChusslevel
	VorlageUpgrade\Kosten = 55
	VorlageUpgrade\Menge = 1
	
	VorlageUpgrade = New TVorlageUpgrade
	VorlageUpgrade\ID = 3 ;Energie
	VorlageUpgrade\Kosten = 50
	VorlageUpgrade\Menge = 10
	
End Function

Function EnemyVorlagen()
	Local Nummer = 1
	
	VorlageGegner.TVorlageGegner = New TVorlageGegner
	VorlageGegner\ID = 1
	VorlageGegner\Speed# = Rnd(3.6,4.0)
	VorlageGegner\SchussTimer = 1200
	VorlageGegner\Erfahrung = 10
	VorlageGegner\Level = 1
	VorlageGegner\Nr = Nummer
	Nummer = Nummer + 1
	VorlageGegner\Energie# = 100
	VorlageGegner\Image = BildErstellen(Drache, 3, 50)
	
	VorlageGegner.TVorlageGegner = New TVorlageGegner
	VorlageGegner\ID = 2
	VorlageGegner\Speed# = Rnd(3.9,4.4)
	VorlageGegner\SchussTimer = 1100
	VorlageGegner\Erfahrung = 17
	VorlageGegner\Level = 2
	VorlageGegner\Nr = Nummer
	Nummer = Nummer + 1
	VorlageGegner\Energie# = 200
	VorlageGegner\Image = BildErstellen(Gargoyle, 2, 100)
	
	VorlageGegner.TVorlageGegner = New TVorlageGegner
	VorlageGegner\ID = 3
	VorlageGegner\Speed# = Rnd(2.6,2.7)
	VorlageGegner\SchussTimer = 970
	VorlageGegner\Erfahrung = 29
	VorlageGegner\Level = 3
	VorlageGegner\Nr = Nummer
	Nummer = Nummer + 1
	VorlageGegner\Energie# = 290
	VorlageGegner\Image = BildErstellen(Gegner3, 2, 150)
	
	VorlageGegner.TVorlageGegner = New TVorlageGegner
	VorlageGegner\ID = 4
	VorlageGegner\Speed# = Rnd(4.2,4.4)
	VorlageGegner\SchussTimer = 920
	VorlageGegner\Erfahrung = 40
	VorlageGegner\Level = 4
	VorlageGegner\Nr = Nummer
	Nummer = Nummer + 1
	VorlageGegner\Energie# = 350
	VorlageGegner\Image = BildErstellen(Loeffel, 3, 120)
	
End Function

Function EnemySchussVorlagen()
	
	VorlageSchussGegner.TVorlageSchussGegner = New TVorlageSchussGegner
	VorlageSchussGegner\ID = 1
	VorlageSchussGegner\Speed# = Rnd(5.8,6.3)
	VorlageSchussGegner\Kraft = 10
	VorlageSchussGegner\Image = BildErstellen(MesserShoot, 2, 70)
	
	VorlageSchussGegner.TVorlageSchussGegner = New TVorlageSchussGegner
	VorlageSchussGegner\ID = 2
	VorlageSchussGegner\Speed# = Rnd(6.2,6.7)
	VorlageSchussGegner\Kraft = 25
	VorlageSchussGegner\Image = BildErstellen(Feuerball, 2, 100)
	
	VorlageSchussGegner.TVorlageSchussGegner = New TVorlageSchussGegner
	VorlageSchussGegner\ID = 3
	VorlageSchussGegner\Speed# = Rnd(4.6,5.0)
	VorlageSchussGegner\Kraft = 35
	VorlageSchussGegner\Image = BildErstellen(GegnerSchuss3, 0, 0)
	
	VorlageSchussGegner.TVorlageSchussGegner = New TVorlageSchussGegner
	VorlageSchussGegner\ID = 4
	VorlageSchussGegner\Speed# = Rnd(4.6,5.0)
	VorlageSchussGegner\Kraft = 35
	VorlageSchussGegner\Image = BildErstellen(Suppe, 2, 100)
	
End Function

Function PlayerSchussVorlagen()
	
	VorlageSchussSpieler.TVorlageSchussSpieler = New TVorlageSchussSpieler
	VorlageSchussSpieler\ID = 1
	VorlageSchussSpieler\Speed# = 5.8
	VorlageSchussSpieler\Image = BildErstellen(Blitz, 4, 50)
	VorlageSchussSpieler\Kraft = 100
	
	VorlageSchussSpieler.TVorlageSchussSpieler = New TVorlageSchussSpieler
	VorlageSchussSpieler\ID = 2
	VorlageSchussSpieler\Speed# = 6.2
	VorlageSchussSpieler\Image = BildErstellen(FireBall, 4, 65)
	VorlageSchussSpieler\Kraft = 130
	
	VorlageSchussSpieler.TVorlageSchussSpieler = New TVorlageSchussSpieler
	VorlageSchussSpieler\ID = 3
	VorlageSchussSpieler\Speed# = 6.4
	VorlageSchussSpieler\Image = BildErstellen(PlasmaBall, 2, 120)
	VorlageSchussSpieler\Kraft = 170
	
	VorlageSchussSpieler.TVorlageSchussSpieler = New TVorlageSchussSpieler
	VorlageSchussSpieler\ID = 4
	VorlageSchussSpieler\Speed# = 7.1
	VorlageSchussSpieler\Image = BildErstellen(Wasserball, 4, 65)
	VorlageSchussSpieler\Kraft = 230
	
	VorlageSchussSpieler.TVorlageSchussSpieler = New TVorlageSchussSpieler
	VorlageSchussSpieler\ID = 5
	VorlageSchussSpieler\Speed# = 7.3
	VorlageSchussSpieler\Image = BildErstellen(BonBon, 2, 120)
	VorlageSchussSpieler\Kraft = 290
	
End Function

Function GeldVorlage()
	VorlageGeld.TVorlageGeld = New TVorlageGeld
	VorlageGeld\ID = 1
	VorlageGeld\Image = BildErstellen(Geld1, 2, 130)
	VorlageGeld\Menge = 8
	VorlageGeld\Speed# = 4.5
End Function
;~IDEal Editor Parameters:
;~F#2#D#14#1B#22#28#3B#6C#88#AA
;~C#Blitz3D